import * as React from 'react';
export declare namespace AsyncStatusIndicator {
    type AsyncStatusIndicatorState = 'ready' | 'processing' | 'success' | 'error';
    type Props = {
        /** The state of the component */
        state: AsyncStatusIndicatorState;
        /** an optional class name to pass to top level element of the component */
        className?: string;
        /** an optional style object to pass to top level element of the component */
        style?: React.CSSProperties;
        /** a dictionary of ReactElements for each state */
        icons: {
            [key in AsyncStatusIndicatorState]?: any;
        };
        /** a dictionary labels for each state */
        labels: {
            [key in AsyncStatusIndicatorState]?: string;
        };
    };
}
/** A component that shows the status of an async operation */
export declare class AsyncStatusIndicator extends React.PureComponent<AsyncStatusIndicator.Props> {
    render(): JSX.Element;
}
