import * as React from 'react';
import * as bowser from 'bowser';
export declare namespace BrowserDetector {
    type Browser = keyof bowser.IBowserVersions;
    type DetectedBrowser = bowser.IBowserGrade;
    type Props = {
        /** children node rendered when using a supported browser */
        children: JSX.Element;
        /** called when using a non-supported browser. Expected to return a valid ReactNode */
        placeholder: (detectedBrowser: DetectedBrowser) => JSX.Element;
        /** whitelist of supported browsers. If `undefined` they're all supported */
        supportedBrowsers?: Browser[];
        /** custom user-agent */
        userAgent?: string;
    };
}
/**
 * Top-level component which detects browser and renders children/placeholder
 * based on a given whitelist of supported browsers.
 */
export declare class BrowserDetector extends React.PureComponent<BrowserDetector.Props> {
    detectBrowser(userAgent: string): BrowserDetector.DetectedBrowser;
    shouldRenderPlaceholder(supportedBrowsers: BrowserDetector.Browser[], detectedBrowser: BrowserDetector.DetectedBrowser): boolean;
    render(): JSX.Element & React.ReactNode;
}
