"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Button = void 0;
var React = __importStar(require("react"));
var classnames_1 = __importDefault(require("classnames"));
var every = require("lodash/every");
var utils_1 = require("../utils");
var TextOverflow_1 = require("../TextOverflow/TextOverflow");
var react_flexview_1 = __importDefault(require("react-flexview"));
var LoadingSpinner_1 = require("../LoadingSpinner/LoadingSpinner");
var log_1 = require("../utils/log");
// util
var notBoth = function (a, b) { return !(a && b); };
var satisfyAll = function () {
    var conditions = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        conditions[_i] = arguments[_i];
    }
    return function (props) { return every(conditions, function (c) { return c(props); }); };
};
// invariants
var propsInvariants = [
    function (_a) {
        var label = _a.label, icon = _a.icon, children = _a.children;
        return notBoth(label || icon, children);
    },
    function (_a) {
        var primary = _a.primary, flat = _a.flat;
        return notBoth(primary, flat);
    },
    function (_a) {
        var fluid = _a.fluid, circular = _a.circular;
        return notBoth(fluid, circular);
    },
    function (_a) {
        var circular = _a.circular, icon = _a.icon, label = _a.label;
        return !circular || !!(icon && !label);
    },
    function (_a) {
        var type = _a.type, primary = _a.primary, flat = _a.flat;
        return notBoth(type, flat || primary);
    } // notBothTypeAndItsShortucts
];
var defaultLabels = {
    success: 'success',
    error: 'error',
    processing: 'processing'
};
var defaultSuccessIcon = (React.createElement("svg", { className: "default-success-icon", width: "16", height: "16", viewBox: "0 0 28 28" },
    React.createElement("title", null, "check"),
    React.createElement("path", { d: "M26.109 8.844q0 0.625-0.438 1.062l-13.438 13.438q-0.438 0.438-1.062 0.438t-1.062-0.438l-7.781-7.781q-0.438-0.438-0.438-1.062t0.438-1.062l2.125-2.125q0.438-0.438 1.062-0.438t1.062 0.438l4.594 4.609 10.25-10.266q0.438-0.438 1.062-0.438t1.062 0.438l2.125 2.125q0.438 0.437 0.438 1.062z" })));
var defaultErrorIcon = (React.createElement("svg", { className: "default-error-icon", width: "10", height: "16", viewBox: "0 0 10 28" },
    React.createElement("title", null, "exclamation"),
    React.createElement("path", { d: "M8 19.5v3.5q0 0.406-0.297 0.703t-0.703 0.297h-4q-0.406 0-0.703-0.297t-0.297-0.703v-3.5q0-0.406 0.297-0.703t0.703-0.297h4q0.406 0 0.703 0.297t0.297 0.703zM8.469 3l-0.438 12q-0.016 0.406-0.32 0.703t-0.711 0.297h-4q-0.406 0-0.711-0.297t-0.32-0.703l-0.438-12q-0.016-0.406 0.273-0.703t0.695-0.297h5q0.406 0 0.695 0.297t0.273 0.703z" })));
var defaultIcons = {
    success: defaultSuccessIcon,
    error: defaultErrorIcon
};
var Button = /** @class */ (function (_super) {
    __extends(Button, _super);
    function Button() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.templateLoading = function () { return (React.createElement(react_flexview_1.default, { className: "button-loading", shrink: false, vAlignContent: "center", hAlignContent: "center" },
            React.createElement(LoadingSpinner_1.LoadingSpinner, { size: "1em", overlayColor: "transparent" }))); };
        _this.templateIcon = function (icon) { return (React.createElement(react_flexview_1.default, { className: "button-icon", shrink: false }, icon)); };
        // TODO: the popover props is not handled by TextOverflow
        _this.templateLabel = function (label, TextOverflow) { return (React.createElement(react_flexview_1.default, { className: "button-label", column: true, shrink: false, vAlignContent: "center", hAlignContent: "center" },
            React.createElement(TextOverflow, { label: label, popover: { offsetY: -8 } }))); };
        return _this;
    }
    Button.prototype.componentDidMount = function () {
        if (process.env.NODE_ENV !== 'production') {
            if (!satisfyAll.apply(void 0, propsInvariants)(this.props)) {
                (0, log_1.warn)('Button: some prop invariant is not satisfied');
            }
        }
    };
    Button.prototype.render = function () {
        var _a = this.props, buttonState = _a.buttonState, circular = _a.circular, _className = _a.className, flat = _a.flat, fluid = _a.fluid, _icon = _a.icon, _label = _a.label, children = _a.children, onClick = _a.onClick, primary = _a.primary, size = _a.size, style = _a.style, textOverflow = _a.textOverflow, type = _a.type;
        var l = _label || children;
        var labels = __assign(__assign({}, defaultLabels), (typeof l === 'string' ? { ready: l, 'not-allowed': l } : l));
        var icons = __assign(__assign({}, defaultIcons), (_icon && React.isValidElement(_icon) ? { ready: _icon, 'not-allowed': _icon } : _icon));
        var getButtonType = function () { return type || (primary && 'primary') || (flat && 'flat') || 'default'; };
        var wrapperStyle = {
            display: fluid ? 'block' : 'inline-block',
            width: fluid ? '100%' : undefined
        };
        var isIconButton = function () { return !!_icon && !_label; };
        var className = (0, classnames_1.default)((0, utils_1.stateClassUtil)([getButtonType()]), { 'icon-button': isIconButton() }, { circular: circular }, (0, utils_1.stateClassUtil)([size]), _className);
        var label = labels[buttonState];
        var icon = icons[buttonState];
        var loading = buttonState === 'processing';
        return (React.createElement("div", { className: "button", style: wrapperStyle },
            React.createElement(react_flexview_1.default, { className: (0, classnames_1.default)('button-inner', className, (0, utils_1.stateClassUtil)([buttonState])), vAlignContent: "center", hAlignContent: "center", onClick: buttonState === 'ready' ? onClick : function () { }, style: style },
                loading && this.templateLoading(),
                icon && this.templateIcon(icon),
                label && this.templateLabel(label, textOverflow))));
    };
    Button.defaultProps = {
        textOverflow: TextOverflow_1.TextOverflow,
        buttonState: 'ready',
        size: 'small',
        fluid: false,
        primary: false,
        circular: false,
        className: '',
        style: {}
    };
    return Button;
}(React.PureComponent));
exports.Button = Button;
