"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.StatefulButton = void 0;
var React = __importStar(require("react"));
var Button_1 = require("./Button");
var log_1 = require("../utils/log");
var StatefulButton = /** @class */ (function (_super) {
    __extends(StatefulButton, _super);
    function StatefulButton(props) {
        var _this = _super.call(this, props) || this;
        _this._isMounted = false;
        _this.state = {
            internalState: null
        };
        _this.doResetInternalState = function () {
            if (_this._isMounted) {
                _this.setState({
                    internalState: null
                });
            }
        };
        _this.doResetInternalStateAfterTimer = function () {
            _this.timeoutId = setTimeout(function () {
                _this.timeoutId = null;
                _this.doResetInternalState();
            }, _this.props.timerMillis);
        };
        _this.attachPromiseHandlers = function (promise) {
            promise
                .then(function () {
                return (_this._isMounted &&
                    _this.setState({
                        internalState: 'success'
                    }, function () {
                        if (!_this.props.stableSuccess) {
                            _this.doResetInternalStateAfterTimer();
                        }
                        else if (_this.resetInternalStateAfterProcessing) {
                            _this.doResetInternalState();
                        }
                    }));
            })
                .catch(function () {
                if (_this._isMounted) {
                    _this.setState({
                        internalState: 'error'
                    }, function () { return _this.doResetInternalStateAfterTimer(); });
                }
            });
        };
        _this.getButtonState = function () { return _this.props.buttonState || _this.state.internalState || _this.props.baseState; };
        _this.onClick = function (e) {
            if (_this.getButtonState() === 'ready') {
                _this.resetInternalStateAfterProcessing = false;
                var promise_1 = _this.props.onClick(e);
                if (!_this.props.buttonState) {
                    _this.setState({
                        internalState: 'processing'
                    }, function () { return _this.attachPromiseHandlers(promise_1); });
                }
            }
        };
        _this.timeoutId = null;
        _this.resetInternalStateAfterProcessing = false;
        return _this;
    }
    StatefulButton.prototype.componentDidMount = function () {
        this._isMounted = true;
    };
    StatefulButton.prototype.componentWillUnmount = function () {
        this._isMounted = false;
    };
    StatefulButton.prototype.componentDidUpdate = function (prevProps) {
        if (process.env.NODE_ENV !== 'production') {
            if (this.props.stableSuccess !== prevProps.stableSuccess) {
                (0, log_1.warn)('StatefulButton: changing the "stableSuccess" prop is not supported');
            }
        }
        if (this.props.buttonState) {
            if (this.timeoutId) {
                clearTimeout(this.timeoutId);
                this.timeoutId = null;
            }
        }
        if (this.props.baseState !== prevProps.baseState) {
            if (this.state.internalState === 'processing') {
                this.resetInternalStateAfterProcessing = true;
            }
            else {
                this.doResetInternalState();
            }
        }
    };
    StatefulButton.prototype.render = function () {
        var _a = this.props, baseState = _a.baseState, stableSuccess = _a.stableSuccess, timerMillis = _a.timerMillis, buttonProps = __rest(_a, ["baseState", "stableSuccess", "timerMillis"]);
        return React.createElement(Button_1.Button, __assign({}, buttonProps, { onClick: this.onClick, buttonState: this.getButtonState() }));
    };
    StatefulButton.defaultProps = {
        stableSuccess: false,
        timerMillis: 2000
    };
    return StatefulButton;
}(React.PureComponent));
exports.StatefulButton = StatefulButton;
