import * as React from 'react';
export type CheckboxRequiredProps = {
    /** value */
    value: boolean;
    /** onChange */
    onChange: (value: boolean) => void;
    /** text displayed on the right of the checkbox */
    text?: string;
    /** called when the input is focused */
    onFocus?: React.FocusEventHandler<HTMLElement>;
    /** called when the input is blurred */
    onBlur?: React.FocusEventHandler<HTMLElement>;
    className?: string;
    id?: string;
    style?: React.CSSProperties;
};
export type CheckboxDefaultProps = {
    /** true if disabled */
    disabled: boolean;
    /** true if readOnly */
    readOnly: boolean;
};
export declare namespace Checkbox {
    type Props = CheckboxRequiredProps & Partial<CheckboxDefaultProps>;
}
export declare class Checkbox extends React.PureComponent<Checkbox.Props> {
    static defaultProps: CheckboxDefaultProps;
    onToggleCheckbox: () => void;
    toggleOnSpace: (event: React.KeyboardEvent<HTMLElement>) => void;
    render(): JSX.Element;
}
