import * as React from 'react';
export declare namespace DateField {
    type Props = {
        /** current value expressed as JS Date */
        value?: Date;
        /** called when there is a new valid value */
        onChange: (value: Date) => void;
        /** called when validity changes */
        onValidChange: (isValid: boolean) => void;
        /** map to pass placeholders to each input field */
        placeholders?: {
            day?: string;
            month?: string;
            year?: string;
        };
        /** if `true`, it passes `type='number'` to every input field */
        inputTypeNumber?: boolean;
        /** an optional class name to pass to top level element of the component */
        className?: string;
        /** an optional style object to pass to top level element of the component */
        style?: React.CSSProperties;
        /** an optional id to pass to top level element of the component */
        id?: string;
    };
}
export type State = {
    day: string;
    month: string;
    year: string;
    isDirty: boolean;
    isValid: boolean;
};
/**
 *  A simple component used to visually divide UI elements
 */
export declare class DateField extends React.PureComponent<DateField.Props, State> {
    state: State;
    componentDidUpdate(prevProps: DateField.Props): void;
    isDigit(value: string): boolean;
    onChange: (key: 'day' | 'month' | 'year') => React.ChangeEventHandler<HTMLInputElement>;
    isValid({ year, month, day }: State): boolean;
    render(): JSX.Element;
}
