"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DateField = void 0;
var React = __importStar(require("react"));
var every = require("lodash/every");
var classnames_1 = __importDefault(require("classnames"));
var react_flexview_1 = __importDefault(require("react-flexview"));
function parseDate(date) {
    return {
        day: String(date.getDate()),
        month: String(date.getMonth() + 1),
        year: String(date.getFullYear())
    };
}
var initialState = {
    day: '',
    month: '',
    year: '',
    isDirty: false,
    isValid: false
};
/**
 *  A simple component used to visually divide UI elements
 */
var DateField = /** @class */ (function (_super) {
    __extends(DateField, _super);
    function DateField() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = _this.props.value
            ? __assign(__assign({}, parseDate(_this.props.value)), { isValid: true, isDirty: false }) : initialState;
        _this.onChange = function (key) { return function (_a) {
            var _b, _c;
            var value = _a.target.value;
            if (value.length === 0) {
                _this.setState(__assign(__assign({}, _this.state), (_b = {}, _b[key] = value, _b.isValid = false, _b.isDirty = true, _b)));
                return;
            }
            // exit if value is not a number
            if (!_this.isDigit(value)) {
                return;
            }
            var patch = (_c = {},
                _c[key] = value,
                _c);
            var values = __assign(__assign({}, _this.state), patch);
            var isValid = _this.isValid(values);
            if (_this.state.isValid !== isValid) {
                _this.props.onValidChange && _this.props.onValidChange(isValid);
            }
            _this.setState(__assign(__assign({ isValid: isValid }, patch), { isDirty: true }), function () {
                if (isValid &&
                    every([_this.state.day, _this.state.month, _this.state.year], function (s) { return s.length > 0; })) {
                    _this.props.onChange(new Date(parseInt(_this.state.year), parseInt(_this.state.month) - 1, parseInt(_this.state.day)));
                }
            });
        }; };
        return _this;
    }
    DateField.prototype.componentDidUpdate = function (prevProps) {
        if (!this.props.value && prevProps.value) {
            // "value" has become "undefined"
            this.setState({ day: '', month: '', year: '', isValid: false });
        }
        else if ((this.props.value && !prevProps.value) ||
            (this.props.value &&
                prevProps.value &&
                this.props.value.getTime() !== prevProps.value.getTime())) {
            // "value" exists and has changed
            var _a = parseDate(this.props.value), day = _a.day, month = _a.month, year = _a.year;
            // this logic is needed to avoid transforming the user input "07" in the parsed number "7"
            if (parseInt(day) !== parseInt(this.state.day) ||
                parseInt(month) !== parseInt(this.state.month) ||
                parseInt(year) !== parseInt(this.state.year)) {
                this.setState({ day: day, month: month, year: year });
            }
        }
    };
    DateField.prototype.isDigit = function (value) {
        return /^\d+$/.test(value);
    };
    DateField.prototype.isValid = function (_a) {
        var year = _a.year, month = _a.month, day = _a.day;
        var _date = new Date(parseInt(year), parseInt(month) - 1, parseInt(day));
        return (parseInt(year) === _date.getFullYear() &&
            parseInt(month) === _date.getMonth() + 1 &&
            parseInt(day) === _date.getDate());
    };
    DateField.prototype.render = function () {
        var _a = this, _b = _a.props, className = _b.className, id = _b.id, style = _b.style, _c = _b.placeholders, placeholders = _c === void 0 ? {} : _c, _d = _b.inputTypeNumber, inputTypeNumber = _d === void 0 ? false : _d, _e = _a.state, day = _e.day, month = _e.month, year = _e.year, isValid = _e.isValid, isDirty = _e.isDirty, onChange = _a.onChange;
        var type = inputTypeNumber ? 'number' : undefined;
        return (React.createElement(react_flexview_1.default, { className: (0, classnames_1.default)('date-field', className, {
                'is-invalid': isDirty && !isValid
            }), id: id, style: style },
            React.createElement("input", { className: "day-field", value: day, placeholder: placeholders.day, onChange: onChange('day'), type: type }),
            React.createElement("input", { className: "month-field", value: month, placeholder: placeholders.month, onChange: onChange('month'), type: type }),
            React.createElement("input", { className: "year-field", value: year, placeholder: placeholders.year, onChange: onChange('year'), type: type })));
    };
    return DateField;
}(React.PureComponent));
exports.DateField = DateField;
