import * as React from 'react';
export type DividerDefaultProps = {
    /** divider orientation (vertical | horizontal) */
    orientation: Divider.Orientation;
    /** size of margins */
    size: Divider.Size;
    /** an optional style object to pass to top level element of the component */
    style: React.CSSProperties;
    /** an optional class name to pass to first inner element of the component */
    className?: string;
};
export declare namespace Divider {
    type Orientation = 'horizontal' | 'vertical';
    type Size = 'small' | 'medium' | 'large' | 'no-margin';
    type Props = Partial<DividerDefaultProps>;
}
/**
 * A simple component used to visually divide UI elements
 */
export declare class Divider extends React.PureComponent<Divider.Props> {
    static defaultProps: DividerDefaultProps;
    render(): JSX.Element;
}
