import * as React from 'react';
import { CommonProps, DefaultProps } from './commons';
export type NonDefaultProps<OptionType> = Omit<CommonProps<OptionType, false>, 'isMulti'> & ({
    isClearable: true;
    value: OptionType | null;
    onChange: (value: OptionType | null) => void;
} | {
    isClearable?: false;
    value: OptionType;
    onChange: (value: OptionType) => void;
});
export type DropdownProps<OptionType> = NonDefaultProps<OptionType> & Partial<DefaultProps>;
export declare class Dropdown<OptionType> extends React.PureComponent<DropdownProps<OptionType>> {
    static defaultProps: DefaultProps;
    render(): JSX.Element;
}
