import * as React from 'react';
import { ActionMeta, GroupBase, MultiValue, ValueContainerProps } from 'react-select';
import { CommonProps, DefaultProps } from './commons';
export declare function allSelected<OptionType = never>(): SelectAllValue<OptionType>;
export declare function someSelected<OptionType>(values: OptionType[]): SelectAllValue<OptionType>;
type SelectAllOptionType = {
    value: '_ALL';
    label: string;
};
export type SelectAllValue<OptionType> = {
    type: 'AllSelected';
} | {
    type: 'SomeSelected';
    values: OptionType[];
};
type NonDefaultProps<OptionType> = Omit<CommonProps<OptionType | SelectAllOptionType, true>, 'isMulti'> & {
    selectAllLabel: string;
    value: SelectAllValue<OptionType>;
    onChange: (value: SelectAllValue<OptionType>) => void;
    options: CommonProps<OptionType, true>['options'];
};
export type MultiDropdownWithSelectAllProps<OptionType> = NonDefaultProps<OptionType> & Partial<DefaultProps>;
export declare class MultiDropdownWithSelectAll<OptionType> extends React.PureComponent<MultiDropdownWithSelectAllProps<OptionType>> {
    static defaultProps: DefaultProps;
    selectAllOption: SelectAllOptionType;
    valueContainer: (valueContainerProps: ValueContainerProps<OptionType | SelectAllOptionType, true>) => JSX.Element;
    injectSelectAllOptions: (options: MultiDropdownWithSelectAllProps<OptionType>['options']) => Array<OptionType | SelectAllOptionType> | Array<GroupBase<OptionType | SelectAllOptionType>>;
    onChange: (newValue: MultiValue<SelectAllOptionType | OptionType>, _meta: ActionMeta<OptionType | SelectAllOptionType>) => void;
    render(): JSX.Element;
}
export {};
