"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MultiDropdownWithSelectAll = exports.someSelected = exports.allSelected = void 0;
var React = __importStar(require("react"));
var react_select_1 = __importStar(require("react-select"));
var creatable_1 = __importDefault(require("react-select/creatable"));
var classnames_1 = __importDefault(require("classnames"));
var commons_1 = require("./commons");
function allSelected() {
    return { type: 'AllSelected' };
}
exports.allSelected = allSelected;
function someSelected(values) {
    return { type: 'SomeSelected', values: values };
}
exports.someSelected = someSelected;
function isGroupedOptionsArray(options) {
    return options.length > 0 && options[0].hasOwnProperty('options');
}
var MultiDropdownWithSelectAll = /** @class */ (function (_super) {
    __extends(MultiDropdownWithSelectAll, _super);
    function MultiDropdownWithSelectAll() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.selectAllOption = {
            value: '_ALL',
            label: _this.props.selectAllLabel
        };
        // if this component is defined inside the render method, the search input will lose focus
        // every time the component is re-rendered (e.g. every time we set new async options)
        _this.valueContainer = function (valueContainerProps) {
            if (_this.props.value && _this.props.value.type === 'AllSelected') {
                var children = valueContainerProps.children, otherProps = __rest(valueContainerProps, ["children"]);
                var childrenWithoutValues = React.Children.toArray(children).filter(function (c) { return !!c && c.type.name !== 'MultiValue'; });
                return (React.createElement(react_select_1.components.ValueContainer, __assign({}, otherProps),
                    !valueContainerProps.selectProps.inputValue && ( // hide the 'All' value if the user is searching for something
                    React.createElement(react_select_1.components.SingleValue, __assign({}, otherProps, { data: _this.selectAllOption, innerProps: {}, isDisabled: false }), _this.selectAllOption.label)),
                    childrenWithoutValues));
            }
            else {
                return React.createElement(react_select_1.components.ValueContainer, __assign({}, valueContainerProps));
            }
        };
        _this.injectSelectAllOptions = function (options) {
            if (isGroupedOptionsArray(options)) {
                return __spreadArray([{ options: [_this.selectAllOption] }], options, true);
            }
            else {
                return __spreadArray([_this.selectAllOption], options, true);
            }
        };
        _this.onChange = function (newValue, _meta) {
            var valueArray = newValue && Array.isArray(newValue) ? newValue : [];
            if (valueArray.length > 0 && valueArray[valueArray.length - 1] == _this.selectAllOption) {
                _this.props.onChange({ type: 'AllSelected' });
            }
            else {
                _this.props.onChange({
                    type: 'SomeSelected',
                    values: valueArray.filter(function (a) { return a !== _this.selectAllOption; })
                });
            }
        };
        return _this;
    }
    MultiDropdownWithSelectAll.prototype.render = function () {
        var _a = this.props, className = _a.className, customComponents = _a.components, allowCreate = _a.allowCreate, size = _a.size, flat = _a.flat, _options = _a.options, innerRef = _a.innerRef, selectAllValue = _a.value, props = __rest(_a, ["className", "components", "allowCreate", "size", "flat", "options", "innerRef", "value"]);
        var Component = allowCreate ? creatable_1.default : react_select_1.default;
        var dropdownValue = selectAllValue
            ? selectAllValue.type === 'AllSelected'
                ? this.selectAllOption
                : selectAllValue.values
            : [];
        return (React.createElement(Component, __assign({ classNamePrefix: "dropdown", className: (0, classnames_1.default)((0, commons_1.getCommonClassnames)(size, flat || false, props.isSearchable), 'is-multi', className), styles: commons_1.defaultStyle }, props, { value: dropdownValue, onChange: this.onChange, options: this.injectSelectAllOptions(_options), components: __assign(__assign(__assign({}, (0, commons_1.defaultComponents)()), { ValueContainer: this.valueContainer }), customComponents), ref: innerRef, isSearchable: allowCreate || props.isSearchable, isMulti: true })));
    };
    MultiDropdownWithSelectAll.defaultProps = commons_1.defaultProps;
    return MultiDropdownWithSelectAll;
}(React.PureComponent));
exports.MultiDropdownWithSelectAll = MultiDropdownWithSelectAll;
