/// <reference types="react" />
import Select, { GroupBase, Props as SelectProps } from 'react-select';
import { CreatableProps } from 'react-select/creatable';
export type DefaultProps = {
    delimiter: NonNullable<SelectProps['delimiter']>;
    size: 'medium' | 'small';
    isSearchable: NonNullable<SelectProps['isSearchable']>;
    menuPlacement: NonNullable<SelectProps['menuPlacement']>;
};
export type CommonProps<OptionType, IsMulti extends boolean> = Omit<SelectProps<OptionType, IsMulti>, 'onChange' | 'value' | 'disabled' | 'options'> & {
    flat?: boolean;
    innerRef?: (ref: Select | null) => void;
    options: NonNullable<SelectProps<OptionType>['options']>;
    style?: React.CSSProperties;
} & (({
    allowCreate: true;
    isSearchable?: never;
} & CreatableProps<OptionType, false, GroupBase<OptionType>>) | {
    allowCreate?: never;
});
export declare const defaultProps: DefaultProps;
export declare const defaultComponents: <OptionType extends unknown, IsMulti extends boolean>() => Partial<import("react-select/dist/declarations/src/components").SelectComponents<OptionType, IsMulti, GroupBase<OptionType>>> | undefined;
export declare const getCommonClassnames: (size: DefaultProps['size'], flat: boolean, isSearchable: boolean) => string;
export declare const defaultStyle: {
    input: () => {
        margin: number;
        padding: number;
    };
};
