"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FocusableView = void 0;
var React = __importStar(require("react"));
var classnames_1 = __importDefault(require("classnames"));
var debounce = require("lodash/debounce");
/**
 * A panel that can get focus
 */
var FocusableView = /** @class */ (function (_super) {
    __extends(FocusableView, _super);
    function FocusableView() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.defaultedProps = function () { return _this.props; };
        _this.state = { focused: false };
        _this._mounted = false;
        _this._onFocus = function () {
            _this.setState({ focused: true });
            _this.defaultedProps().onFocus();
        };
        _this._onBlur = function () {
            _this.setState({ focused: false });
            _this.defaultedProps().onBlur();
        };
        _this._onFocusBlurEvent = function (type) {
            var _a = _this, _mounted = _a._mounted, focused = _a.state.focused;
            if (!_mounted) {
                return;
            }
            if (type === 'blur' && focused) {
                _this._onBlur();
            }
            else if (type === 'focus' && !focused) {
                _this._onFocus();
            }
        };
        _this.onFocusBlurEventDebounced = debounce(_this._onFocusBlurEvent, _this.defaultedProps().debounce);
        _this.onFocusBlurEvent = function (_a) {
            var type = _a.type;
            return _this.defaultedProps().debounce != null
                ? _this.onFocusBlurEventDebounced(type)
                : _this._onFocusBlurEvent(type);
        };
        return _this;
    }
    FocusableView.prototype.componentDidMount = function () {
        this._mounted = true;
    };
    FocusableView.prototype.componentWillUnmount = function () {
        this._mounted = false;
    };
    FocusableView.prototype.render = function () {
        var _a = this, onFocusBlurEvent = _a.onFocusBlurEvent, focused = _a.state.focused;
        var _b = this.defaultedProps(), className = _b.className, ignoreFocus = _b.ignoreFocus, children = _b.children, component = _b.component, debounce = _b.debounce, props = __rest(_b, ["className", "ignoreFocus", "children", "component", "debounce"]);
        var locals = __assign(__assign({}, props), { className: !ignoreFocus ? (0, classnames_1.default)(className, { focused: focused }) : className, onFocus: onFocusBlurEvent, onBlur: onFocusBlurEvent });
        return React.createElement(component, locals, typeof children === 'function' ? children(focused) : children);
    };
    FocusableView.defaultProps = {
        ignoreFocus: false,
        component: 'div',
        tabIndex: 0,
        onFocus: function () { },
        onBlur: function () { }
    };
    return FocusableView;
}(React.Component));
exports.FocusableView = FocusableView;
