import * as React from 'react';
import Checkbox from '../Checkbox';
import { FormField } from './FormField';
type DefaultProps = {
    /** an optional custom renderer for Checkbox */
    checkboxRenderer: (props: Checkbox.Props) => JSX.Element;
};
type NonDefaultProps = {
    /** the label for the field */
    label: FormField.Props['label'];
    /** whether the field is required */
    required?: FormField.Props['required'];
    /** optional props to pass to the wrapping View */
    viewProps?: FormField.Props['viewProps'];
    /** an optional class name to pass to top level element of the component */
    className?: string;
    /** an optional style object to pass to top level element of the component */
    style?: React.CSSProperties;
    /** an optional id passed to the input component */
    id?: string;
    /** the properties of the checkbox*/
    checkboxProps: Checkbox.Props;
};
type InternalProps = DefaultProps & NonDefaultProps;
export declare namespace CheckboxField {
    type Props = NonDefaultProps & Partial<DefaultProps>;
}
export declare class CheckboxField extends React.PureComponent<InternalProps> {
    static defaultProps: DefaultProps;
    render(): JSX.Element;
}
export {};
