"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FormField = void 0;
var React = __importStar(require("react"));
var classnames_1 = __importDefault(require("classnames"));
var react_flexview_1 = __importDefault(require("react-flexview"));
var Popover_1 = __importDefault(require("../Popover"));
var leftArrow = (React.createElement("svg", { className: "form-field-hint-left-arrow", width: "5.75", height: "12", viewBox: "0 0 5.75 12" },
    React.createElement("path", { d: "M5.75 0.67L5.68 11.86L0.06 6.17L5.75 0.67Z" })));
var FormField = /** @class */ (function (_super) {
    __extends(FormField, _super);
    function FormField() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = { focused: false, mouseover: false };
        _this.stateChange = function (k, value) { return function () {
            _this.setState(function (s) {
                var _a;
                return (__assign(__assign({}, s), (_a = {}, _a[k] = value, _a)));
            });
        }; };
        _this.renderFieldWithHint = function (render, hint) {
            var Field = (React.createElement(React.Fragment, { key: "no-hint" }, render(_this.stateChange('focused', true), _this.stateChange('focused', false))));
            if (hint) {
                switch (hint.type) {
                    case 'label':
                        return (React.createElement(react_flexview_1.default, { grow: true, column: true, key: "label-hint" },
                            Field,
                            React.createElement(react_flexview_1.default, { className: (0, classnames_1.default)('form-field-hint', 'form-field-hint-label') }, hint.content)));
                    case 'box':
                        return (React.createElement(react_flexview_1.default, { grow: true, key: "box-hint" },
                            Field,
                            React.createElement(react_flexview_1.default, { shrink: false, className: (0, classnames_1.default)('form-field-hint', 'form-field-hint-box') }, hint.content)));
                    case 'tooltip':
                        return (React.createElement(Popover_1.default, { key: "popover-hint", className: (0, classnames_1.default)('form-field-hint', 'form-field-hint-tooltip'), popover: __assign(__assign({ position: 'right', anchor: 'start', isOpen: _this.state.focused || _this.state.mouseover }, hint.popover), { content: (React.createElement(react_flexview_1.default, { style: { pointerEvents: 'none' } },
                                    React.createElement(react_flexview_1.default, { shrink: false }, leftArrow),
                                    React.createElement(react_flexview_1.default, { grow: true, className: "form-field-hint-content" }, hint.content))) }) }, Field));
                }
            }
            return Field;
        };
        return _this;
    }
    FormField.prototype.render = function () {
        var _a = this.props, label = _a.label, required = _a.required, disabled = _a.disabled, _className = _a.className, _viewProps = _a.viewProps, horizontal = _a.horizontal, onLabelClick = _a.onLabelClick, render = _a.render, hint = _a.hint;
        var className = (0, classnames_1.default)('form-field', _className, {
            'is-disabled': disabled,
            'is-required': required,
            'is-horizontal': horizontal
        });
        var labelStyle = onLabelClick
            ? { cursor: 'pointer', userSelect: 'none' }
            : {};
        var labelComponent = (React.createElement(react_flexview_1.default, { className: "form-field-label", vAlignContent: "center", key: "label" },
            React.createElement(react_flexview_1.default, { className: "label", onClick: onLabelClick, style: labelStyle }, label)));
        var fieldComponent = this.renderFieldWithHint(render, hint);
        return (React.createElement(react_flexview_1.default, __assign({ grow: !horizontal }, _viewProps, { className: className, onMouseOver: this.stateChange('mouseover', true), onMouseOut: this.stateChange('mouseover', false) }),
            React.createElement(react_flexview_1.default, { grow: true, column: !horizontal }, horizontal ? [fieldComponent, labelComponent] : [labelComponent, fieldComponent])));
    };
    return FormField;
}(React.PureComponent));
exports.FormField = FormField;
