import * as React from 'react';
import { SingleDropdownProps as DropdownProps } from '../Dropdown';
import { FormField } from './FormField';
type DefaultProps<OptionType> = {
    /** An optional custom renderer for Dropdown */
    dropdownRenderer: (props: DropdownProps<OptionType>) => JSX.Element;
};
type NonDefaultProps<OptionType> = {
    /** the label for the field */
    label: FormField.Props['label'];
    /** whether the field is required */
    required?: FormField.Props['required'];
    /** optional props to pass to the wrapping View */
    viewProps?: FormField.Props['viewProps'];
    /** an optional hint describing what's the expected value for the field (e.g. sample value or short description) */
    hint?: FormField.Props['hint'];
    /** an optional class name to pass to top level element of the component */
    className?: string;
    /** an optional style object to pass to top level element of the component */
    style?: React.CSSProperties;
    /** an optional id passed to the dropdown component */
    id?: string;
    /** the properties of the dropdown */
    dropdownProps: DropdownProps<OptionType>;
};
type InternalProps<OptionType> = NonDefaultProps<OptionType> & DefaultProps<OptionType>;
export declare namespace SingleDropdownField {
    type Props<OptionType> = NonDefaultProps<OptionType> & Partial<DefaultProps<OptionType>>;
}
export declare class SingleDropdownField<OptionType> extends React.PureComponent<InternalProps<OptionType>> {
    static defaultProps: DefaultProps<unknown>;
    render(): JSX.Element;
}
export {};
