"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FormattedText = void 0;
var React = __importStar(require("react"));
var flattenDeep = require("lodash/flattenDeep");
var linkify_it_1 = __importDefault(require("linkify-it"));
// TODO: replace "require" with "import"... for some reason they're workin only with "require"
var tlds = require('tlds');
var linkify = (0, linkify_it_1.default)();
linkify.tlds(tlds);
var FormattedText = /** @class */ (function (_super) {
    __extends(FormattedText, _super);
    function FormattedText() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    FormattedText.prototype.linkify = function (string) {
        var matches = linkify.match(string);
        if (matches) {
            return matches.reduce(function (acc, match, i) {
                var nextMatch = matches[i + 1];
                return __spreadArray(__spreadArray([], (acc || [string.slice(0, match.index)]), true), [
                    React.createElement("a", { href: match.url, target: "_blank" }, match.raw),
                    string.slice(match.lastIndex, nextMatch ? nextMatch.index : undefined)
                ], false);
            }, null);
        }
        else {
            return string;
        }
    };
    FormattedText.prototype.replaceLinksWithA = function (children) {
        var _this = this;
        return flattenDeep(children.map(function (child) {
            if (typeof child === 'string') {
                return _this.linkify(child);
            }
            else {
                return child;
            }
        }));
    };
    FormattedText.prototype.replaceBreaklinesWithBR = function (children) {
        var paragraphs = children.split(/\n/g);
        return flattenDeep(paragraphs.map(function (paragraph, i) {
            var br = React.createElement("br", { key: "br-".concat(i) });
            var p = React.createElement(React.Fragment, { key: "paragraph-".concat(i) }, paragraph);
            if (paragraph.length === 0) {
                return br;
            }
            else if (i < paragraphs.length - 1) {
                return [p, br];
            }
            else {
                return p;
            }
        }));
    };
    FormattedText.prototype.render = function () {
        var _a = this.props, children = _a.children, linkify = _a.linkify, props = __rest(_a, ["children", "linkify"]);
        var formattedText = this.replaceBreaklinesWithBR(children);
        var newProps = __assign(__assign({}, props), { children: linkify ? this.replaceLinksWithA(formattedText) : formattedText });
        return React.createElement("span", __assign({}, newProps));
    };
    return FormattedText;
}(React.PureComponent));
exports.FormattedText = FormattedText;
