"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getBackgroundUrl = void 0;
var cloudinaryId = 'buildo';
var cloudinaryBaseUrl = "https://res.cloudinary.com/".concat(cloudinaryId, "/image/fetch/");
function isRetinaDisplay() {
    if (window.matchMedia) {
        var mq = window.matchMedia('only screen and (min--moz-device-pixel-ratio: 1.3), only screen and (-o-min-device-pixel-ratio: 2.6/2), only screen and (-webkit-min-device-pixel-ratio: 1.3), only screen  and (min-device-pixel-ratio: 1.3), only screen and (min-resolution: 1.3dppx)');
        return (mq && mq.matches) || window.devicePixelRatio > 1;
    }
    return false;
}
function getUrl(src, _a) {
    var _b = _a === void 0 ? {} : _a, _width = _b.width, _height = _b.height, _quality = _b.quality, _format = _b.format;
    var isAbsolute = src.indexOf('http') >= 0;
    var isBase64 = src.slice(0, 5) === 'data:';
    if (isBase64) {
        return src;
    }
    var origin = !isAbsolute ? window.location.origin : '';
    var width = _width ? "w_".concat(isRetinaDisplay() ? _width * 2 : _width, "/") : '';
    var height = _height ? "h_".concat(isRetinaDisplay() ? _height * 2 : _height, "/") : '';
    var quality = _quality ? "q_".concat(_quality, "/") : '';
    var format = _format ? "f_".concat(_format, "/") : '';
    var cloudinaryUrl = "".concat(cloudinaryBaseUrl).concat(format).concat(width).concat(height).concat(quality).concat(origin).concat(src);
    return process.env.NODE_ENV !== 'development' ? cloudinaryUrl : src;
}
var getBackgroundUrl = function (src, cloudinaryParams) {
    return "url(".concat(getUrl(src, cloudinaryParams), ")");
};
exports.getBackgroundUrl = getBackgroundUrl;
exports.default = getUrl;
