import * as React from 'react';
export type ConfirmationInputRequiredProps = {
    /** input placeholder */
    placeholder?: string;
    /** labels for 'clear' and 'toConfirm' buttons */
    text: {
        clear?: string;
        toConfirm?: string;
    };
    /** icons for 'clear' and 'toConfirm' buttons */
    icon: {
        clear?: JSX.Element;
        toConfirm?: JSX.Element;
    };
    /** an optional class name to pass to top level element of the component */
    className?: string;
    /** component's id */
    id?: string;
    /** an optional style object to pass to top level element of the component */
    style?: React.CSSProperties;
};
export type ConfirmationInputDefaultProps = {
    /** initial value */
    initialValue: string;
    /** true if disabled */
    disabled: boolean;
    /** called when input box content is changed */
    onChange: (value: string) => void;
    /** called when confirming input content */
    onConfirm: (value: string) => void;
    /** called when clearing confirmed content */
    onClear: () => void;
};
export declare namespace ConfirmationInput {
    type ConfirmProps = {
        text?: string;
        icon?: JSX.Element;
        onMouseDown: () => void;
        onMouseEnter: () => void;
        onMouseLeave: () => void;
    } | undefined;
    type Props = ConfirmationInputRequiredProps & Partial<ConfirmationInputDefaultProps>;
}
export type State = {
    focused: boolean;
    hoveringConfirm: boolean;
    value: string;
};
export declare class ConfirmationInput extends React.PureComponent<ConfirmationInput.Props, State> {
    static defaultProps: ConfirmationInputDefaultProps;
    state: {
        focused: boolean;
        hoveringConfirm: boolean;
        value: string;
    };
    componentDidUpdate(prevProps: ConfirmationInput.Props): void;
    onEnter: (e: React.KeyboardEvent<HTMLInputElement>) => void;
    onBlur: () => void;
    onFocus: () => void;
    onMouseEnter: () => void;
    onMouseLeave: () => void;
    _onConfirm: () => void;
    _onClear: () => void;
    _onChange: (value: string) => void;
    render(): JSX.Element;
}
