"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ConfirmationInput = void 0;
var React = __importStar(require("react"));
var classnames_1 = __importDefault(require("classnames"));
var omit = require("lodash/omit");
var Input_1 = require("../Input/Input");
var react_flexview_1 = __importDefault(require("react-flexview"));
var ConfirmationInput = /** @class */ (function (_super) {
    __extends(ConfirmationInput, _super);
    function ConfirmationInput() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            focused: false,
            hoveringConfirm: false,
            value: _this.props.initialValue || ''
        };
        _this.onEnter = function (e) {
            if (e.which === 13 || e.keyCode === 13) {
                // if Enter key
                _this._onConfirm();
                document.activeElement.blur(); // remove focus
            }
        };
        _this.onBlur = function () {
            var hoveringConfirm = _this.state.hoveringConfirm;
            if (!hoveringConfirm) {
                _this._onConfirm();
            }
            _this.setState({ focused: false });
        };
        _this.onFocus = function () {
            _this.setState({ focused: true });
        };
        _this.onMouseEnter = function () { return _this.setState({ hoveringConfirm: true }); };
        _this.onMouseLeave = function () { return _this.setState({ hoveringConfirm: false }); };
        _this._onConfirm = function () {
            var _a = _this.props, initialValue = _a.initialValue, onConfirm = _a.onConfirm, onChange = _a.onChange;
            var _b = _this, value = _b.state.value, onMouseLeave = _b.onMouseLeave;
            var confirmed = value === initialValue || (!value && !initialValue);
            if (!confirmed) {
                onConfirm(value);
                onChange(value);
                if (!value) {
                    onMouseLeave(); // on confirm, if value is empty, `templateConfirm` disappears -> onMouseLeave never called
                }
            }
        };
        _this._onClear = function () {
            var _a = _this.props, onClear = _a.onClear, onChange = _a.onChange;
            onClear();
            onChange(''); // props.onChange should always receive a string
            _this.onMouseLeave(); // on clear `templateConfirm` disappears -> onMouseLeave never called
        };
        _this._onChange = function (value) { return _this.setState({ value: value }); };
        return _this;
    }
    ConfirmationInput.prototype.componentDidUpdate = function (prevProps) {
        if (this.props.initialValue !== prevProps.initialValue) {
            this.setState({
                value: this.props.initialValue || ''
            });
        }
    };
    ConfirmationInput.prototype.render = function () {
        var _a = this
            .props, className = _a.className, initialValue = _a.initialValue, text = _a.text, icon = _a.icon, props = __rest(_a, ["className", "initialValue", "text", "icon"]);
        var _b = this, _c = _b.state, value = _c.value, focused = _c.focused, onClear = _b._onClear, onConfirm = _b._onConfirm, onChange = _b._onChange, onMouseEnter = _b.onMouseEnter, onMouseLeave = _b.onMouseLeave;
        var confirmed = value === initialValue || (!value && !initialValue);
        var showToConfirm = !confirmed;
        var showClear = value && confirmed && !focused;
        var confirmProps = showToConfirm || showClear
            ? {
                text: text[confirmed ? 'clear' : 'toConfirm'],
                icon: icon[confirmed ? 'clear' : 'toConfirm'],
                wrapper: {
                    style: { cursor: 'pointer' },
                    className: 'confirmation',
                    vAlignContent: 'center',
                    onMouseDown: showClear ? onClear : onConfirm,
                    onMouseEnter: onMouseEnter,
                    onMouseLeave: onMouseLeave
                }
            }
            : undefined;
        var inputProps = __assign(__assign({}, omit(props, 'onChange', 'onConfirm', 'onClear')), { value: value, onChange: onChange, onKeyUp: this.onEnter, onBlur: this.onBlur, onFocus: this.onFocus, className: (0, classnames_1.default)('confirmation-input', { focused: focused }, className) });
        return (React.createElement(Input_1.Input, __assign({}, inputProps), confirmProps && (React.createElement(react_flexview_1.default, __assign({}, confirmProps.wrapper),
            confirmProps.icon,
            confirmProps.text))));
    };
    ConfirmationInput.defaultProps = {
        initialValue: '',
        disabled: false,
        onChange: function () { },
        onConfirm: function () { },
        onClear: function () { }
    };
    return ConfirmationInput;
}(React.PureComponent));
exports.ConfirmationInput = ConfirmationInput;
