import * as React from 'react';
import { ObjectOverwrite, Children } from '../utils';
import InputChildren from 'react-input-children';
export type InputStatus = 'success' | 'failure';
export type InputRequiredProps = ObjectOverwrite<InputChildren.Props, {
    /** value */
    value: string;
    /** onChange */
    onChange: (value: string) => void;
    /** input children */
    children?: Children;
    /** optional input status */
    status?: InputStatus;
    /** don't use this. Use `innerRef` instead */
    ref?: never;
}>;
export type InputDefaultProps = {
    /** true if disabled */
    disabled: boolean;
};
export declare namespace Input {
    type Props = InputRequiredProps & Partial<InputDefaultProps>;
}
export declare class Input extends React.PureComponent<Input.Props> {
    static defaultProps: InputDefaultProps;
    _onChange: React.ChangeEventHandler<HTMLInputElement>;
    render(): JSX.Element;
}
