import * as React from 'react';
import { InputRequiredProps, InputDefaultProps } from '../Input/Input';
export type PasswordInputRequiredProps = InputRequiredProps;
export type PasswordInputDefaultProps = InputDefaultProps & {
    /** text label for the "hide" button */
    hideText: string;
    /** text label for the "show" button */
    showText: string;
};
export declare namespace PasswordInput {
    type Props = PasswordInputRequiredProps & Partial<PasswordInputDefaultProps>;
}
export type State = {
    show: boolean;
};
export declare class PasswordInput extends React.PureComponent<PasswordInput.Props, State> {
    static defaultProps: PasswordInputDefaultProps;
    state: {
        show: boolean;
    };
    onToggleClick: () => void;
    render(): JSX.Element;
}
