import * as React from 'react';
export type LoadingSpinnerDefaultProps = {
    /** spinner size */
    size: string | number;
    /** dimmed-overlay color */
    overlayColor: string;
    style: React.CSSProperties;
};
export type LoadingSpinnerRequiredProps = {
    /** spinner main color */
    color?: string;
    /** spinner message */
    message?: {
        content: string;
        color?: string;
        size?: string | number;
    };
    id?: string;
    className?: string;
};
export declare namespace LoadingSpinner {
    type Props = LoadingSpinnerRequiredProps & Partial<LoadingSpinnerDefaultProps>;
}
/**
 * Absolute dimmed layer with loading spinner in the center
 */
export declare class LoadingSpinner extends React.PureComponent<LoadingSpinner.Props> {
    private loadingSpinner;
    static defaultProps: LoadingSpinnerDefaultProps;
    componentDidMount(): void;
    getMessage: () => JSX.Element | undefined;
    logWarnings: () => void;
    render(): JSX.Element;
}
