"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.LoadingSpinner = void 0;
var React = __importStar(require("react"));
var classnames_1 = __importDefault(require("classnames"));
var log_1 = require("../utils/log");
/**
 * Absolute dimmed layer with loading spinner in the center
 */
var LoadingSpinner = /** @class */ (function (_super) {
    __extends(LoadingSpinner, _super);
    function LoadingSpinner() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.loadingSpinner = null;
        _this.getMessage = function () {
            var _a = _this.props, message = _a.message, size = _a.size;
            if (message) {
                var messageStyle = {
                    marginTop: size,
                    fontSize: message.size || 16,
                    color: message.color
                };
                return (React.createElement("div", { className: "message", style: messageStyle }, message.content));
            }
            return undefined;
        };
        _this.logWarnings = function () {
            (0, log_1.warn)(function () {
                if (!_this.loadingSpinner)
                    return undefined;
                var parentElement = _this.loadingSpinner.parentElement;
                var position = window.getComputedStyle(parentElement).position;
                if (position !== 'relative' && position !== 'absolute') {
                    return [
                        'LoadingSpinner\'s parent node style should have "position: relative" or "position: absolute"',
                        parentElement
                    ];
                }
                return undefined;
            });
        };
        return _this;
    }
    LoadingSpinner.prototype.componentDidMount = function () {
        this.logWarnings();
    };
    LoadingSpinner.prototype.render = function () {
        var _this = this;
        var _a = this
            .props, size = _a.size, color = _a.color, overlayColor = _a.overlayColor, id = _a.id, _className = _a.className, style = _a.style;
        var overlayStyle = { backgroundColor: overlayColor };
        var spinnerStyle = {
            fontSize: size,
            color: color
        };
        var className = (0, classnames_1.default)('loading-spinner', _className);
        return (React.createElement("div", { className: className, style: style, id: id, ref: function (ls) {
                _this.loadingSpinner = ls;
            } },
            React.createElement("div", { className: "loading-spinner-overlay", style: overlayStyle },
                React.createElement("div", { className: "spinner", style: spinnerStyle }),
                this.getMessage())));
    };
    LoadingSpinner.defaultProps = {
        size: '3em',
        overlayColor: 'rgba(255, 255, 255, .9)',
        style: {}
    };
    return LoadingSpinner;
}(React.PureComponent));
exports.LoadingSpinner = LoadingSpinner;
