import * as React from 'react';
export type ActionsMenuRequiredProps = {
    options?: ActionsMenu.Option[];
    maxHeight?: number;
};
export type ActionsMenuDefaultProps = {
    style: React.CSSProperties;
    onClick: () => void;
};
export declare namespace ActionsMenu {
    type Option = {
        type: 'title' | 'item' | 'divider';
        title?: JSX.Element | string;
        metadata?: JSX.Element | string;
        selected?: boolean;
        disabled?: boolean;
        onClick?: OptionClickHandler;
    };
    type OptionClickHandler = (o: Option) => void;
    type Props = ActionsMenuRequiredProps & Partial<ActionsMenuDefaultProps>;
}
export type State = {
    height: number | null;
};
export declare class ActionsMenu extends React.PureComponent<ActionsMenu.Props, State> {
    constructor(props: ActionsMenu.Props);
    getProps(): {
        options?: ActionsMenu.Option[] | undefined;
        maxHeight?: number | undefined;
        style: React.CSSProperties;
        onClick: () => void;
        children?: React.ReactNode;
    };
    componentDidMount(): void;
    onOptionClick: ActionsMenu.OptionClickHandler;
    menuActionTemplate: (option: ActionsMenu.Option, onOptionClick: ActionsMenu.OptionClickHandler) => JSX.Element;
    templateRenderedOptions: ({ options, onOptionClick }: {
        options?: ActionsMenu.Option[] | undefined;
        onOptionClick: ActionsMenu.OptionClickHandler;
    }) => JSX.Element[] | undefined;
    render(): JSX.Element;
}
