"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Menu = void 0;
var React = __importStar(require("react"));
var ActionsMenu_1 = require("./ActionsMenu");
var react_flexview_1 = __importDefault(require("react-flexview"));
var Popover_1 = require("../Popover/Popover");
var classnames_1 = __importDefault(require("classnames"));
/**
 *  A menu with actions
 */
var Menu = /** @class */ (function (_super) {
    __extends(Menu, _super);
    function Menu() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.getActionsMenuMaxHeight = function () {
            if (_this.props.maxHeight) {
                return _this.props.maxHeight;
            }
            if (_this.props.size) {
                switch (_this.props.size) {
                    case 'small':
                        return 250;
                    case 'medium':
                        return 400;
                    case 'large':
                        return 600;
                }
            }
            return undefined;
        };
        return _this;
    }
    Menu.prototype.render = function () {
        var _a = this.props, children = _a.children, dismissOnClickOutside = _a.dismissOnClickOutside, className = _a.className, options = _a.options, menuRenderer = _a.menuRenderer, isOpen = _a.isOpen, onClose = _a.onClose, onOpen = _a.onOpen, position = _a.position, anchor = _a.anchor;
        var maxHeight = this.getActionsMenuMaxHeight();
        return (React.createElement(Popover_1.Popover, { popover: {
                isOpen: isOpen,
                dismissOnClickOutside: dismissOnClickOutside,
                position: position ? position : 'bottom',
                anchor: anchor ? anchor : 'end',
                onShow: onOpen,
                onHide: onClose,
                event: 'click',
                className: 'actions-menu-popover',
                dismissOnScroll: false,
                content: menuRenderer ? (menuRenderer(options)) : (React.createElement(ActionsMenu_1.ActionsMenu, { onClick: onClose, options: options, maxHeight: maxHeight }))
            } },
            React.createElement(react_flexview_1.default, { vAlignContent: "center", className: (0, classnames_1.default)('menu', className) }, children)));
    };
    return Menu;
}(React.PureComponent));
exports.Menu = Menu;
