import * as React from 'react';
export type MeterDefaultProps = {
    /** minimum value */
    min: number;
    /** maximum value */
    max: number;
    /** function in which you can define a custom label format */
    labelFormatter: (value: number, min: number, max: number) => string;
};
export type MeterRequiredProps = {
    /** current value */
    value: number;
    /** array of Object in which you can define startValue, endValue, labelColor, fillingColor */
    ranges?: Meter.Range[];
    /** fallback labelColor */
    baseLabelColor?: string;
    /** fallback fillingColor */
    baseFillingColor?: string;
    /** fallback backgroundColor */
    baseBackgroundColor?: string;
    id?: string;
    className?: string;
    style?: React.CSSProperties;
};
export declare namespace Meter {
    type Range = {
        startValue: number;
        endValue: number;
        fillingColor?: string;
        labelColor?: string;
        backgroundColor?: string;
    };
    type Props = MeterRequiredProps & Partial<MeterDefaultProps>;
}
/**
 * A Meter displays a measurement (usually a percentage) on a known scale.
 */
export declare class Meter extends React.PureComponent<Meter.Props> {
    static defaultProps: MeterDefaultProps;
    componentDidMount(): void;
    logWarnings: () => void;
    computeStyles: () => {
        basisSize: string;
        fillingStyle: {
            background: string | undefined;
        };
        labelStyle: {
            color: string | undefined;
        };
        barStyle: {
            background: string | undefined;
        };
    };
    render(): JSX.Element;
}
