import * as React from 'react';
import MobileDetect from 'mobile-detect';
import * as PropTypes from 'prop-types';
export declare namespace MobileDetector {
    type ChildrenArgs = {
        isDesktop: boolean;
        isMobile: boolean;
        isPhone: boolean;
        isTablet: boolean;
    };
    type Props = {
        /** children must be passed as function so to propagte context correctly. Environment info is also passed as first argument to the callback */
        children: (childrenArgs: ChildrenArgs) => JSX.Element;
        /** ignores real device type and considers it as desktop */
        forceDesktop?: boolean;
        /** custom user-agent */
        userAgent?: string;
    };
}
/**
 * Top-level component which detects device type and passes this info to children as context
 */
export declare class MobileDetector extends React.Component<MobileDetector.Props> {
    static childContextTypes: {
        isDesktop: PropTypes.Validator<boolean>;
        isMobile: PropTypes.Validator<boolean>;
        isPhone: PropTypes.Validator<boolean>;
        isTablet: PropTypes.Validator<boolean>;
    };
    getChildContext: () => {
        isDesktop: boolean;
        isMobile: boolean;
        isPhone: boolean;
        isTablet: boolean;
    };
    getEnvironmentInfo: () => {
        isDesktop: boolean;
        isMobile: boolean;
        isPhone: boolean;
        isTablet: boolean;
    };
    isPhone: (md: MobileDetect) => boolean;
    isTablet: (md: MobileDetect) => boolean;
    isMobile: (md: MobileDetect) => boolean;
    render(): JSX.Element;
}
