"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MobileDetector = void 0;
var React = __importStar(require("react"));
var mobile_detect_1 = __importDefault(require("mobile-detect"));
var PropTypes = __importStar(require("prop-types"));
/**
 * Top-level component which detects device type and passes this info to children as context
 */
var MobileDetector = /** @class */ (function (_super) {
    __extends(MobileDetector, _super);
    function MobileDetector() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.getChildContext = function () { return _this.getEnvironmentInfo(); };
        _this.getEnvironmentInfo = function () {
            var md = new mobile_detect_1.default(_this.props.userAgent || window.navigator.userAgent);
            return {
                isDesktop: !_this.isMobile(md),
                isMobile: _this.isMobile(md),
                isPhone: _this.isPhone(md),
                isTablet: _this.isTablet(md)
            };
        };
        _this.isPhone = function (md) { return !_this.props.forceDesktop && !!md.phone(); };
        _this.isTablet = function (md) { return !_this.props.forceDesktop && !!md.tablet(); };
        _this.isMobile = function (md) { return !_this.props.forceDesktop && !!md.mobile(); };
        return _this;
    }
    MobileDetector.prototype.render = function () {
        return this.props.children(this.getEnvironmentInfo());
    };
    MobileDetector.childContextTypes = {
        isDesktop: PropTypes.bool.isRequired,
        isMobile: PropTypes.bool.isRequired,
        isPhone: PropTypes.bool.isRequired,
        isTablet: PropTypes.bool.isRequired
    };
    return MobileDetector;
}(React.Component));
exports.MobileDetector = MobileDetector;
