import * as React from 'react';
import { Children } from '../utils';
export type BackgroundDimmerRequiredProps = {
    /** children nodes/elements */
    children: Children;
    /** called when user clicks outside children */
    onClickOutside?: (e: React.SyntheticEvent<HTMLDivElement>) => void;
    /** component's class */
    className?: string;
    /** component's id */
    id?: string;
    /** component's style */
    style?: React.CSSProperties;
};
export type BackgroundDimmerDefaultProps = {
    /** background-color */
    color: string;
    /** opacity */
    alpha: number;
    /** z-index (BackgroundDimmer has `position: fixed`) */
    zIndex: number;
    /** centeredContentWrapper width */
    width: string | number;
    /** centeredContentWrapper max-width */
    maxWidth: string | number;
    /** centeredContentWrapper height */
    height: string | number;
    /** centeredContentWrapper max-height */
    maxHeight: string | number;
    /** avoid propagation for scroll events */
    stopScrollPropagation: boolean;
};
export declare namespace BackgroundDimmer {
    type Props = BackgroundDimmerRequiredProps & Partial<BackgroundDimmerDefaultProps>;
}
export declare class BackgroundDimmer extends React.PureComponent<BackgroundDimmer.Props> {
    private mainContentWrapper;
    static defaultProps: BackgroundDimmerDefaultProps;
    isEventOutsideChildren: (e: React.SyntheticEvent<HTMLDivElement> & {
        srcElement?: EventTarget;
    }) => boolean | null;
    onClick: (e: React.SyntheticEvent<HTMLDivElement>) => void;
    stopPropagation: (e: React.SyntheticEvent<HTMLDivElement>) => void;
    preventDefault: (e: React.SyntheticEvent<HTMLDivElement>) => void;
    stopScrollPropagation: (e: React.SyntheticEvent<HTMLDivElement>) => void;
    render(): JSX.Element;
}
