"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.BackgroundDimmer = void 0;
var React = __importStar(require("react"));
var classnames_1 = __importDefault(require("classnames"));
var react_flexview_1 = __importDefault(require("react-flexview"));
var omit = require("lodash/omit");
var utils_1 = require("../utils");
var BackgroundDimmer = /** @class */ (function (_super) {
    __extends(BackgroundDimmer, _super);
    function BackgroundDimmer() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.mainContentWrapper = null;
        // srcElement is not declared in React.SyntheticEvent cause it's a key used by old
        // IE versions: https://msdn.microsoft.com/en-us/library/ms534638(v=vs.85).aspx
        // TODO: should be removed in the future
        _this.isEventOutsideChildren = function (e) {
            var el = e.target || e.srcElement;
            return _this.mainContentWrapper && el === (0, utils_1.findDOMNode)(_this.mainContentWrapper);
        };
        _this.onClick = function (e) {
            var onClickOutside = _this.props.onClickOutside;
            if (onClickOutside) {
                onClickOutside(e);
            }
        };
        _this.stopPropagation = function (e) { return e.stopPropagation(); };
        _this.preventDefault = function (e) { return e.preventDefault(); };
        _this.stopScrollPropagation = function (e) {
            if (_this.props.stopScrollPropagation && _this.isEventOutsideChildren(e)) {
                _this.preventDefault(e);
            }
        };
        return _this;
    }
    BackgroundDimmer.prototype.render = function () {
        var _this = this;
        var _a = this.props, className = _a.className, zIndex = _a.zIndex, color = _a.color, opacity = _a.alpha, width = _a.width, maxWidth = _a.maxWidth, height = _a.height, maxHeight = _a.maxHeight, children = _a.children, props = __rest(_a, ["className", "zIndex", "color", "alpha", "width", "maxWidth", "height", "maxHeight", "children"]);
        var _b = this, onClick = _b.onClick, stopPropagation = _b.stopPropagation, stopScrollPropagation = _b.stopScrollPropagation;
        var fixedStyle = {
            position: 'fixed',
            top: 0,
            left: 0,
            right: 0,
            bottom: 0
        };
        var overlayProps = {
            style: __assign(__assign({}, fixedStyle), { zIndex: zIndex, backgroundColor: color, opacity: opacity })
        };
        var mainContentWrapperProps = {
            onClick: onClick,
            onWheel: stopScrollPropagation,
            onTouchMove: stopScrollPropagation,
            style: __assign(__assign({}, fixedStyle), { zIndex: zIndex + 1 }),
            className: 'main-content-wrapper',
            vAlignContent: 'center',
            hAlignContent: 'center',
            ref: function (ref) {
                _this.mainContentWrapper = ref;
            }
        };
        var centeredContentWrapperProps = {
            className: 'centered-content-wrapper',
            style: { width: width, maxWidth: maxWidth, height: height, maxHeight: maxHeight },
            onClick: stopPropagation,
            column: true
        };
        return (React.createElement("div", __assign({ className: (0, classnames_1.default)('background-dimmer', className) }, omit(props, ['onClickOutside', 'stopScrollPropagation'])),
            React.createElement("div", __assign({}, overlayProps)),
            React.createElement(react_flexview_1.default, __assign({}, mainContentWrapperProps),
                React.createElement(react_flexview_1.default, __assign({}, centeredContentWrapperProps), children))));
    };
    BackgroundDimmer.defaultProps = {
        color: 'black',
        alpha: 0.5,
        zIndex: 99999,
        width: 'auto',
        maxWidth: '90%',
        height: 'auto',
        maxHeight: '90%',
        stopScrollPropagation: false
    };
    return BackgroundDimmer;
}(React.PureComponent));
exports.BackgroundDimmer = BackgroundDimmer;
