import * as React from 'react';
import { ModalPortal } from './ModalPortal';
export type ModalDefaultProps = {
    /** whether the modal should be dismissed when clicking outside it */
    dismissOnClickOutside: boolean;
    /** called when modal is dismissed */
    onDismiss: (e: React.SyntheticEvent<HTMLDivElement>) => void;
    /** specify 'color' and 'alpha' for the overlay layer */
    overlay: {
        color: string;
        alpha?: number;
    } | {
        color?: string;
        alpha: number;
    };
};
export type ModalRequiredProps = {
    /** modal content */
    children: JSX.Element;
    /** modal title */
    title?: string;
    /** modal footer */
    footer?: JSX.Element;
    /** close icon */
    iconClose?: JSX.Element;
    className?: string;
    style?: React.CSSProperties;
    id?: string;
};
export type ModalDefaultedProps = ModalPortal.Props & ModalRequiredProps & ModalDefaultProps;
export declare namespace Modal {
    type Props = ModalPortal.Props & ModalRequiredProps & Partial<ModalDefaultProps>;
}
export declare class Modal extends React.Component<Modal.Props> {
    static defaultProps: ModalDefaultProps;
    render(): JSX.Element;
}
