"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Modal = void 0;
var React = __importStar(require("react"));
var classnames_1 = __importDefault(require("classnames"));
var omit = require("lodash/omit");
var ModalPortal_1 = require("./ModalPortal");
var react_flexview_1 = __importDefault(require("react-flexview"));
var BackgroundDimmer_1 = require("./BackgroundDimmer");
var LocalProps = {
    children: true,
    title: true,
    footer: true,
    iconClose: true,
    overlay: true,
    dismissOnClickOutside: true,
    onDismiss: true,
    className: true,
    style: true,
    id: true
};
var Modal = /** @class */ (function (_super) {
    __extends(Modal, _super);
    function Modal() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Modal.prototype.render = function () {
        var _a = this.props, className = _a.className, style = _a.style, id = _a.id, title = _a.title, iconClose = _a.iconClose, footer = _a.footer, overlay = _a.overlay, dismissOnClickOutside = _a.dismissOnClickOutside, onDismiss = _a.onDismiss, children = _a.children, props = __rest(_a, ["className", "style", "id", "title", "iconClose", "footer", "overlay", "dismissOnClickOutside", "onDismiss", "children"]);
        var shouldRenderHeader = !!title || !!iconClose;
        var shouldRenderFooter = !!footer;
        var modalPortalProps = __assign(__assign({}, omit(props, Object.keys(LocalProps))), { className: (0, classnames_1.default)('modal', className) });
        return (React.createElement(ModalPortal_1.ModalPortal, __assign({}, modalPortalProps),
            React.createElement(BackgroundDimmer_1.BackgroundDimmer, __assign({}, __assign(__assign({}, overlay), { style: style, id: id }), { onClickOutside: dismissOnClickOutside ? onDismiss : undefined, maxWidth: 950 }),
                React.createElement(react_flexview_1.default, { className: "modal-content", column: true, grow: true },
                    shouldRenderHeader && (React.createElement(react_flexview_1.default, { className: "modal-header", shrink: false, vAlignContent: "center" },
                        React.createElement(react_flexview_1.default, { className: (0, classnames_1.default)('modal-title'), grow: true }, title),
                        iconClose && (React.createElement(react_flexview_1.default, { className: "modal-icon-close", shrink: false, marginLeft: "auto", onClick: onDismiss }, iconClose)))),
                    React.createElement(react_flexview_1.default, { className: "modal-body", column: true, grow: true }, children),
                    shouldRenderFooter && (React.createElement(react_flexview_1.default, { className: "modal-footer", column: true, shrink: false }, footer))))));
    };
    Modal.defaultProps = {
        onDismiss: function () { },
        dismissOnClickOutside: true,
        overlay: {
            color: 'black',
            alpha: 0.85
        }
    };
    return Modal;
}(React.Component));
exports.Modal = Modal;
