import * as React from 'react';
export declare namespace ModalPortal {
    type Props = {
        children: JSX.Element;
        /** transition enter timeout */
        transitionEnterTimeout: number;
        /** transition leave timeout */
        transitionLeaveTimeout: number;
        /** context types to pass to the modal React tree */
        childContextTypes?: React.ValidationMap<any>;
        /** should return context values to pass to the modal React tree */
        getChildContext?: () => object;
        className?: string;
    };
}
type ContextWrapperProps = {
    modal: () => JSX.Element;
    getChildContext?: () => object;
};
export declare class ModalPortal extends React.Component<ModalPortal.Props> {
    private isOpen;
    render(): null;
    _ContextWrapper: React.ComponentType<ContextWrapperProps>;
    componentDidMount(): void;
    componentDidUpdate(): void;
    componentWillUnmount(): void;
    _cleanup(): void;
    _onLeave: () => number;
    _render(): void;
    _renderModal(): () => JSX.Element;
}
export {};
