"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ModalPortal = void 0;
var React = __importStar(require("react"));
var ReactDOM = __importStar(require("react-dom"));
var TransitionGroup_1 = __importDefault(require("react-transition-group/TransitionGroup"));
var TransitionWrapper_1 = __importDefault(require("../TransitionWrapper"));
var containerNode = null;
var ModalPortal = /** @class */ (function (_super) {
    __extends(ModalPortal, _super);
    function ModalPortal() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.isOpen = false;
        _this._ContextWrapper = (function () {
            var _a;
            var childContextTypes = _this.props.childContextTypes || {};
            var getChildContext = _this.props.getChildContext || (function () { return ({}); });
            return _a = /** @class */ (function (_super) {
                    __extends(ContextWrapper, _super);
                    function ContextWrapper() {
                        var _this = _super !== null && _super.apply(this, arguments) || this;
                        _this.getChildContext = getChildContext;
                        return _this;
                    }
                    ContextWrapper.prototype.render = function () {
                        return this.props.modal();
                    };
                    return ContextWrapper;
                }(React.Component)),
                // eslint-disable-line react/no-multi-comp
                _a.childContextTypes = childContextTypes,
                _a;
        })();
        _this._onLeave = function () { return setTimeout(_this._cleanup); }; // setTimeout is needed to avoid conflicts with ReactTransitionGroup setState
        return _this;
    }
    ModalPortal.prototype.render = function () {
        return null;
    };
    ModalPortal.prototype.componentDidMount = function () {
        this.isOpen = true;
        this._render();
    };
    ModalPortal.prototype.componentDidUpdate = function () {
        this._render();
    };
    ModalPortal.prototype.componentWillUnmount = function () {
        this.isOpen = false;
        this._render();
    };
    ModalPortal.prototype._cleanup = function () {
        if (containerNode) {
            ReactDOM.unmountComponentAtNode(containerNode);
            document.body.removeChild(containerNode);
            containerNode = null;
        }
    };
    ModalPortal.prototype._render = function () {
        if (!containerNode) {
            containerNode = document.createElement('div');
            document.body.appendChild(containerNode);
        }
        var modal = this._renderModal();
        var ContextWrapper = this._ContextWrapper;
        ReactDOM.render(React.createElement(ContextWrapper, { modal: modal }), containerNode);
    };
    ModalPortal.prototype._renderModal = function () {
        var _this = this;
        var _a = this.props, className = _a.className, children = _a.children, transitionEnterTimeout = _a.transitionEnterTimeout, transitionLeaveTimeout = _a.transitionLeaveTimeout;
        return function () { return (React.createElement(TransitionGroup_1.default, null, _this.isOpen ? (React.createElement(TransitionWrapper_1.default, { key: 0, className: className, onLeave: _this._onLeave, transitionEnterTimeout: transitionEnterTimeout, transitionLeaveTimeout: transitionLeaveTimeout }, children)) : null)); };
    };
    return ModalPortal;
}(React.Component));
exports.ModalPortal = ModalPortal;
