import * as React from 'react';
import { Children } from '../utils';
export declare namespace MoreOrLess {
    type Props = {
        /** panel content */
        children: Children;
        /** whether the panel should be expanded or not */
        expanded: boolean;
        /** called on toggle */
        onExpandedChange: (expanded: boolean) => void;
        /** icons for expanded and collapsed panel */
        icons: {
            expanded: JSX.Element;
            collapsed: JSX.Element;
        };
        /** props for wrapper FlexView */
        wrapperProps?: object;
        /** an optional class name to pass to the component */
        className?: string;
        /** an optional style object to pass to the component */
        style?: React.CSSProperties;
    };
}
/**
 * A panel used to alternately display short or long version of the content
 */
export declare class MoreOrLess extends React.PureComponent<MoreOrLess.Props> {
    toggleExpanded: () => void;
    templateExpandButton: (icon: JSX.Element, toggleExpanded: React.EventHandler<React.SyntheticEvent<HTMLDivElement>>) => JSX.Element;
    render(): JSX.Element;
}
