import * as React from 'react';
import { Children } from '../utils';
export declare namespace NavBar {
    type Props = {
        /** Left content: It doesn't shrink nor grow */
        /** Center content. It grows to use all the available space */
        /** Right content. It doesn't shrink nor grow */
        /** Max Width. For css `max-width` */
        content: {
            left?: Children;
            center?: Children;
            right?: Children;
            maxWidth?: string | number;
        };
        /** to set `position: fixed` */
        fixed?: boolean;
        /** shorthand for css `height` */
        height?: string | number;
        /** shorthand for css `background` */
        background?: string;
        /** add class name */
        className?: string;
        /** add custom css style */
        style?: React.CSSProperties;
    };
}
export declare class NavBar extends React.PureComponent<NavBar.Props> {
    render(): JSX.Element;
}
