import * as React from 'react';
export declare namespace Overflow {
    type Props = {
        /** react node initially rendered */
        content: JSX.Element;
        /** react node rendered if `content` overflows its parent */
        contentIfOverflowing: JSX.Element;
        id?: string;
        className?: string;
        style?: React.CSSProperties;
    };
}
export type State = {
    isOverflowing: boolean;
};
/** Util component to render a different react node if the original one overflows its parent. */
export declare class Overflow extends React.Component<Overflow.Props, State> {
    private ref;
    state: {
        isOverflowing: boolean;
    };
    componentDidMount(): void;
    componentDidUpdate(): void;
    getElementWidth(element: Element): number;
    verifyOverflow(): void;
    onResize: () => void;
    render(): JSX.Element;
}
