"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Overflow = void 0;
var React = __importStar(require("react"));
var ResizeSensor_1 = require("../ResizeSensor/ResizeSensor");
/** Util component to render a different react node if the original one overflows its parent. */
var Overflow = /** @class */ (function (_super) {
    __extends(Overflow, _super);
    function Overflow() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.ref = null;
        _this.state = { isOverflowing: false };
        _this.onResize = function () { return _this.verifyOverflow(); };
        return _this;
    }
    Overflow.prototype.componentDidMount = function () {
        this.verifyOverflow();
    };
    Overflow.prototype.componentDidUpdate = function () {
        this.verifyOverflow();
    };
    Overflow.prototype.getElementWidth = function (element) {
        if (element && typeof window !== 'undefined') {
            return parseFloat(window.getComputedStyle(element).width || '');
        }
        return 0;
    };
    Overflow.prototype.verifyOverflow = function () {
        if (typeof window !== 'undefined') {
            var node = this.ref;
            if (node && node.children) {
                var childrenWidth = this.getElementWidth(node.children[0]);
                var parentWidth = this.getElementWidth(node);
                var isOverflowing = childrenWidth > parentWidth;
                if (this.state.isOverflowing !== isOverflowing) {
                    this.setState({ isOverflowing: isOverflowing });
                }
            }
        }
    };
    Overflow.prototype.render = function () {
        var _this = this;
        var _a = this.props, content = _a.content, contentIfOverflowing = _a.contentIfOverflowing, style = _a.style, className = _a.className, id = _a.id;
        var isOverflowing = this.state.isOverflowing;
        return (React.createElement(ResizeSensor_1.ResizeSensor, { debounce: 10, onResize: this.onResize },
            React.createElement("div", __assign({}, { className: className, id: id }, { style: __assign(__assign({}, style), { width: '100%' }), ref: function (ref) {
                    _this.ref = ref;
                } }), isOverflowing ? contentIfOverflowing : content)));
    };
    return Overflow;
}(React.Component));
exports.Overflow = Overflow;
