"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Panel = void 0;
var React = __importStar(require("react"));
var classnames_1 = __importDefault(require("classnames"));
var PanelHeader_1 = require("./PanelHeader");
var capitalize = require("lodash/capitalize");
var LoadingSpinner_1 = require("../LoadingSpinner/LoadingSpinner");
var react_flexview_1 = __importDefault(require("react-flexview"));
/** A simple component used to group elements in a box. */
var Panel = /** @class */ (function (_super) {
    __extends(Panel, _super);
    function Panel() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this._softLoadingActive = false;
        _this._softLoadingTimer = null;
        _this.toggleExpanded = function () {
            if (_this.props.header && _this.props.header.collapse) {
                var _a = _this.props.header.collapse, isCollapsed = _a.isCollapsed, onExpand = _a.onExpand, onCollapse = _a.onCollapse;
                if (isCollapsed) {
                    onExpand();
                }
                else {
                    onCollapse();
                }
            }
        };
        _this.getStyle = function () {
            var style = {};
            if (_this.props.clearMargin) {
                var marginToClear = "margin".concat(capitalize(_this.props.clearMargin));
                style[marginToClear] = 0;
            }
            return __assign(__assign({}, _this.props.style), style);
        };
        _this.templateSoftLoading = function (_a) {
            var softLoading = _a.softLoading, isExpanded = _a.isExpanded;
            return softLoading && isExpanded ? (React.createElement("div", { className: "panel-soft-loader" },
                React.createElement("div", { className: "loader gradient" }),
                React.createElement("div", { className: "loader" }))) : null;
        };
        _this.templateHeader = function (_a) {
            var header = _a.header, isExpanded = _a.isExpanded, toggleExpanded = _a.toggleExpanded;
            return header ? (React.createElement(PanelHeader_1.PanelHeader, { title: header.hideTitleWhenExpanded && isExpanded ? undefined : header.title, size: header.size, content: header.content, menu: header.menu, collapse: header.collapse
                    ? {
                        direction: header.collapse.direction,
                        isExpanded: isExpanded,
                        onToggleExpanded: toggleExpanded
                    }
                    : undefined })) : null;
        };
        _this.templateExpandedContent = function (_a) {
            var children = _a.children, loading = _a.loading;
            return (React.createElement(react_flexview_1.default, { className: "panel-content", column: true, grow: true, style: { position: 'relative' } },
                children,
                loading && React.createElement(LoadingSpinner_1.LoadingSpinner, null)));
        };
        _this.templateCollapsedContent = function (_a) {
            var header = _a.header, verticalDirection = _a.verticalDirection;
            return !verticalDirection && header && header.title ? (React.createElement(react_flexview_1.default, { className: "panel-content", column: true, grow: true },
                React.createElement(react_flexview_1.default, { grow: true, className: "panel-content-title" }, header.title))) : null;
        };
        return _this;
    }
    Panel.prototype.updateSoftLoadingState = function (prevSoftLoading) {
        var _this = this;
        var _a = this.props, softLoading = _a.softLoading, softLoadingDelay = _a.softLoadingDelay;
        if (!softLoading) {
            if (this._softLoadingTimer) {
                clearTimeout(this._softLoadingTimer);
            }
            this._softLoadingActive = false;
            if (prevSoftLoading) {
                this.forceUpdate();
            }
        }
        else if (!prevSoftLoading && softLoading && softLoadingDelay > 0) {
            // delay === 0 is handled without timer
            this._softLoadingTimer = window.setTimeout(function () {
                _this._softLoadingActive = true;
                _this.forceUpdate();
            }, softLoadingDelay);
        }
    };
    Panel.prototype.isSoftLoading = function (softLoading, softLoadingDelay) {
        return this._softLoadingActive || (softLoading && softLoadingDelay === 0); // optimization for the default delay === 0;
    };
    Panel.prototype.componentDidMount = function () {
        this.updateSoftLoadingState(false);
    };
    Panel.prototype.componentDidUpdate = function (oldProps) {
        this.updateSoftLoadingState(oldProps.softLoading);
    };
    Panel.prototype.componentWillUnmount = function () {
        if (this._softLoadingTimer) {
            clearTimeout(this._softLoadingTimer);
        }
    };
    Panel.prototype.render = function () {
        var _a = this.props, header = _a.header, children = _a.children, loading = _a.loading, _softLoading = _a.softLoading, softLoadingDelay = _a.softLoadingDelay, type = _a.type, _className = _a.className, dark = _a.dark;
        var collapsable = !!header && !!header.collapse;
        var isExpanded = !collapsable || !header.collapse.isCollapsed;
        var panelState = isExpanded ? 'expanded' : 'collapsed';
        var directionClass = collapsable ? "collapse-".concat(header.collapse.direction) : '';
        var verticalDirection = collapsable &&
            (header.collapse.direction === 'up' || header.collapse.direction === 'down');
        var themeType = dark ? 'is-dark' : 'is-light';
        var className = (0, classnames_1.default)('panel', type, { collapsable: collapsable }, themeType, directionClass, panelState, _className);
        var style = this.getStyle();
        var toggleExpanded = this.toggleExpanded;
        var softLoading = this.isSoftLoading(_softLoading, softLoadingDelay);
        return (React.createElement(react_flexview_1.default, { className: className, grow: true, style: style, column: true, onClick: !isExpanded ? toggleExpanded : undefined },
            this.templateSoftLoading({ softLoading: softLoading, isExpanded: isExpanded }),
            this.templateHeader({ header: header, isExpanded: isExpanded, toggleExpanded: toggleExpanded }),
            isExpanded
                ? this.templateExpandedContent({ children: children, loading: loading })
                : this.templateCollapsedContent({ header: header, verticalDirection: verticalDirection })));
    };
    Panel.defaultProps = {
        style: {},
        loading: false,
        softLoading: false,
        softLoadingDelay: 0,
        dark: false
    };
    return Panel;
}(React.PureComponent));
exports.Panel = Panel;
