import * as React from 'react';
import { Children } from '../utils';
export type PanelHeaderDefaultProps = {
    size: PanelHeader.HeaderSize;
};
export type PanelHeaderRequiredProps = {
    collapse?: PanelHeader.Collapse;
    content?: Children;
    title?: Children;
    menu?: Children;
};
export type PanelHeaderDefaultedProps = PanelHeaderRequiredProps & PanelHeaderDefaultProps;
export declare namespace PanelHeader {
    type CollapseDirection = 'up' | 'left' | 'down' | 'right';
    type HeaderSize = 'tiny' | 'small' | 'medium';
    type Collapse = {
        direction: CollapseDirection;
        onToggleExpanded: () => void;
        isExpanded?: boolean;
    };
    type Props = PanelHeaderRequiredProps & Partial<PanelHeaderDefaultProps>;
}
export declare class PanelHeader extends React.PureComponent<PanelHeader.Props> {
    static defaultProps: PanelHeaderDefaultProps;
    getIcon: (collapse: PanelHeader.Collapse) => JSX.Element;
    render(): JSX.Element;
    templateExpandIcon: (collapse: PanelHeader.Collapse) => JSX.Element;
    templateTitle: ({ renderTitle, title, collapse }: {
        renderTitle: boolean;
        title: Children;
        collapse?: PanelHeader.Collapse | undefined;
    }) => JSX.Element;
    templateContent: ({ renderContent, content }: {
        renderContent: boolean;
        content: Children;
    }) => JSX.Element | null;
}
