"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PanelHeader = void 0;
var React = __importStar(require("react"));
var utils_1 = require("../utils");
var react_flexview_1 = __importDefault(require("react-flexview"));
var classnames_1 = __importDefault(require("classnames"));
var angleUpIcon = (React.createElement("svg", { version: "1.1", xmlns: "http://www.w3.org/2000/svg", height: "20", viewBox: "0 0 18 28", className: "expand-icon" },
    React.createElement("path", { d: "M16.797 18.5q0 0.203-0.156 0.359l-0.781 0.781q-0.156 0.156-0.359 0.156t-0.359-0.156l-6.141-6.141-6.141 6.141q-0.156 0.156-0.359 0.156t-0.359-0.156l-0.781-0.781q-0.156-0.156-0.156-0.359t0.156-0.359l7.281-7.281q0.156-0.156 0.359-0.156t0.359 0.156l7.281 7.281q0.156 0.156 0.156 0.359z" })));
var angleDownIcon = (React.createElement("svg", { version: "1.1", xmlns: "http://www.w3.org/2000/svg", height: "20", viewBox: "0 0 18 28", className: "expand-icon" },
    React.createElement("path", { d: "M16.797 11.5q0 0.203-0.156 0.359l-7.281 7.281q-0.156 0.156-0.359 0.156t-0.359-0.156l-7.281-7.281q-0.156-0.156-0.156-0.359t0.156-0.359l0.781-0.781q0.156-0.156 0.359-0.156t0.359 0.156l6.141 6.141 6.141-6.141q0.156-0.156 0.359-0.156t0.359 0.156l0.781 0.781q0.156 0.156 0.156 0.359z" })));
var angleLeftIcon = (React.createElement("svg", { version: "1.1", xmlns: "http://www.w3.org/2000/svg", height: "20", viewBox: "0 0 11 28", className: "expand-icon" },
    React.createElement("path", { d: "M9.797 8.5q0 0.203-0.156 0.359l-6.141 6.141 6.141 6.141q0.156 0.156 0.156 0.359t-0.156 0.359l-0.781 0.781q-0.156 0.156-0.359 0.156t-0.359-0.156l-7.281-7.281q-0.156-0.156-0.156-0.359t0.156-0.359l7.281-7.281q0.156-0.156 0.359-0.156t0.359 0.156l0.781 0.781q0.156 0.156 0.156 0.359z" })));
var angleRightIcon = (React.createElement("svg", { version: "1.1", xmlns: "http://www.w3.org/2000/svg", height: "20", viewBox: "0 0 10 28", className: "expand-icon" },
    React.createElement("path", { d: "M9.297 15q0 0.203-0.156 0.359l-7.281 7.281q-0.156 0.156-0.359 0.156t-0.359-0.156l-0.781-0.781q-0.156-0.156-0.156-0.359t0.156-0.359l6.141-6.141-6.141-6.141q-0.156-0.156-0.156-0.359t0.156-0.359l0.781-0.781q0.156-0.156 0.359-0.156t0.359 0.156l7.281 7.281q0.156 0.156 0.156 0.359z" })));
var icons = {
    up: [angleUpIcon, angleDownIcon],
    left: [angleLeftIcon, angleRightIcon],
    down: [angleDownIcon, angleUpIcon],
    right: [angleRightIcon, angleLeftIcon]
};
var PanelHeader = /** @class */ (function (_super) {
    __extends(PanelHeader, _super);
    function PanelHeader() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.getIcon = function (collapse) {
            var direction = collapse.direction, isExpanded = collapse.isExpanded;
            return isExpanded ? icons[direction][0] : icons[direction][1];
        };
        _this.templateExpandIcon = function (collapse) {
            return (React.createElement(react_flexview_1.default, { vAlignContent: "center", hAlignContent: "center", className: "panel-header-icon" }, _this.getIcon(collapse)));
        };
        _this.templateTitle = function (_a) {
            var renderTitle = _a.renderTitle, title = _a.title, collapse = _a.collapse;
            return (React.createElement(react_flexview_1.default, { vAlignContent: "center", shrink: false, onClick: !!collapse && collapse.isExpanded ? collapse.onToggleExpanded : undefined, className: "panel-header-title-wrapper" },
                collapse && _this.templateExpandIcon(collapse),
                renderTitle && React.createElement(react_flexview_1.default, { className: "panel-header-title" }, title)));
        };
        _this.templateContent = function (_a) {
            var renderContent = _a.renderContent, content = _a.content;
            return renderContent ? (React.createElement(react_flexview_1.default, { className: "panel-header-content", vAlignContent: "center", grow: true, shrink: false }, content)) : null;
        };
        return _this;
    }
    PanelHeader.prototype.render = function () {
        var _a = this.props, collapse = _a.collapse, size = _a.size, content = _a.content, title = _a.title, menu = _a.menu;
        var verticalDirection = !!collapse && (collapse.direction === 'up' || collapse.direction === 'down');
        var renderInnerHeader = !collapse || (collapse && (collapse.isExpanded || verticalDirection));
        var renderTitle = !!title && renderInnerHeader;
        var renderContent = !!content && renderInnerHeader;
        var renderMenu = menu && renderInnerHeader;
        var height = size === 'tiny' ? 40 : size === 'medium' ? 56 : 48;
        var className = (0, classnames_1.default)('panel-header', (0, utils_1.stateClassUtil)([size]));
        return (React.createElement(react_flexview_1.default, { className: className, basis: height },
            this.templateTitle({ renderTitle: renderTitle, title: title, collapse: collapse }),
            this.templateContent({ renderContent: renderContent, content: content }),
            renderMenu && menu));
    };
    PanelHeader.defaultProps = {
        size: 'small'
    };
    return PanelHeader;
}(React.PureComponent));
exports.PanelHeader = PanelHeader;
