import * as React from 'react';
import { Panel } from './Panel';
export declare namespace TabbedPanel {
    namespace Tab {
        type Header = string | {
            text: string;
            icon?: JSX.Element;
        };
    }
    type Tabs = {
        basis?: number;
        headers: Tab.Header[] & {
            0: Tab.Header;
        };
        activeIndex?: number;
        onSetActiveTab: (x: number) => void;
    };
    type Props = {
        tabs: Tabs;
    } & Panel.Props;
}
export declare class TabbedPanel extends React.PureComponent<TabbedPanel.Props> {
    onSetActiveTab: (activeTabIndex: number) => void;
    headerTemplate({ headers, activeIndex, onSetActiveTab, basis }: TabbedPanel.Tabs): JSX.Element;
    render(): JSX.Element;
}
