"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Popover = void 0;
var React = __importStar(require("react"));
var ReactDOM = __importStar(require("react-dom"));
var classnames_1 = __importDefault(require("classnames"));
var debounce = require("lodash/debounce");
var uniq = require("lodash/uniq");
var isEqual = require("lodash/isEqual");
var utils_1 = require("../utils");
var NO_SIZE_WRAPPER = 'no-size-wrapper';
/**
 * Composed of two children: trigger (children) and popover. After a particular event on the trigger
 * (usually "hover" or "click") it renders the popover and positions it relative to it.
 */
var Popover = /** @class */ (function (_super) {
    __extends(Popover, _super);
    function Popover() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.children = null;
        _this.initialized = false;
        _this.containerNode = null;
        _this.onMouseEventDebouncedWhenOpen = null;
        _this.onMouseEventDebouncedWhenClosed = null;
        // LIFECYCLE
        _this.state = { isOpen: false };
        // LISTENERS
        _this.addOnClickListener = function () {
            if (_this.getPopoverProps().dismissOnClickOutside) {
                window.addEventListener('click', _this.onClickOutside, false);
            }
        };
        _this.removeOnClickListener = function () {
            if (_this.getPopoverProps().dismissOnClickOutside) {
                window.removeEventListener('click', _this.onClickOutside, false);
            }
        };
        _this.onClickOutside = function (e) {
            if (_this.children) {
                var childrenNode = _this.children;
                var popoverNode = _this.isAbsolute() ? _this.containerNode : childrenNode.children[1];
                // It's safe to assume that the target is going to be a DOM Element
                // See also: https://stackoverflow.com/questions/28900077/why-is-event-target-not-element-in-typescript
                var el = (e.target || e.srcElement);
                if (!_this.isEventInsideTarget(el, childrenNode) &&
                    (!popoverNode || !_this.isEventInsideTarget(el, popoverNode))) {
                    _this.hidePopover();
                }
            }
        };
        _this.addOnScrollListener = function () {
            if (_this.getPopoverProps().dismissOnScroll) {
                window.addEventListener('mousewheel', _this.onScroll, false);
            }
        };
        _this.removeOnScrollListener = function () {
            if (_this.getPopoverProps().dismissOnScroll) {
                window.removeEventListener('mousewheel', _this.onScroll, false);
            }
        };
        _this.onScroll = function () { return _this.hidePopover(); };
        _this.addListeners = function () {
            _this.addOnScrollListener();
            _this.addOnClickListener();
        };
        _this.removeListeners = function () {
            _this.removeOnScrollListener();
            _this.removeOnClickListener();
        };
        // UTILS
        // extend with default values
        _this.getPopoverProps = function (_props) {
            var props = _props || _this.props;
            return __assign(__assign({ position: 'top', anchor: 'center', event: 'hover', onShow: function () { }, onHide: function () { }, onToggle: function () { }, className: '', distance: 5, offsetX: 0, offsetY: 0 }, props.popover), { dismissOnClickOutside: props.popover.dismissOnClickOutside !== false, dismissOnScroll: props.popover.dismissOnScroll !== false });
        };
        _this.getPopoverNode = function () {
            var popover;
            if (_this.isAbsolute()) {
                popover = _this.containerNode ? _this.containerNode.children[0] : null;
            }
            else {
                popover = _this.children ? _this.children.children[1] : null;
            }
            return popover && popover.id === NO_SIZE_WRAPPER ? popover.children[0] : popover;
        };
        _this.getOffsetRect = function (target) {
            var box = target.getBoundingClientRect();
            var body = document.body;
            var docElem = document.documentElement;
            var scrollTop = window.pageYOffset || docElem.scrollTop || body.scrollTop;
            var scrollLeft = window.pageXOffset || docElem.scrollLeft || body.scrollLeft;
            var clientTop = docElem.clientTop || body.clientTop || 0;
            var clientLeft = docElem.clientLeft || body.clientLeft || 0;
            var top = Math.round(box.top + scrollTop - clientTop);
            var left = Math.round(box.left + scrollLeft - clientLeft);
            return { top: top, left: left };
        };
        _this.saveValuesFromNodeTree = function () {
            var popoverNode = _this.getPopoverNode();
            if (_this.children && popoverNode) {
                var _a = _this.children, childWidth = _a.clientWidth, childHeight = _a.clientHeight;
                var popoverHeight = popoverNode.clientHeight, popoverWidth = popoverNode.clientWidth;
                var _b = _this.getOffsetRect(_this.children), childY = _b.top, childX = _b.left;
                var _c = _this.getOffsetRect(popoverNode), popoverY = _c.top, popoverX = _c.left;
                var newState = {
                    child: {
                        width: childWidth,
                        height: childHeight,
                        x: childX,
                        y: childY
                    },
                    popover: {
                        width: popoverWidth,
                        height: popoverHeight,
                        x: popoverX,
                        y: popoverY
                    }
                };
                if (!isEqual(_this.state.child, newState.child) ||
                    !isEqual(_this.state.popover, newState.popover)) {
                    _this.setState(newState);
                }
            }
        };
        _this.isStateful = function (props) { return typeof _this.getPopoverProps(props).isOpen === 'undefined'; };
        _this.isOpen = function (props) {
            return _this.isStateful() ? _this.state.isOpen : _this.getPopoverProps(props).isOpen;
        };
        _this.isEventInsideTarget = function (el, target) {
            if (!el) {
                return false;
            }
            else if (el === target) {
                return true;
            }
            else if (el.parentNode) {
                return _this.isEventInsideTarget(el.parentNode, target);
            }
            else {
                return false;
            }
        };
        // VISIBILITY CHANGE
        _this.appendPopover = function () {
            // create container node
            _this.containerNode = document.createElement('div');
            document.body.appendChild(_this.containerNode);
            // render invisible popover
            var hiddenPopover = _this.getHiddenPopover();
            var context = _this.getPopoverProps().context;
            var ContextWrapper = _this.ContextWrapper;
            // render Popover and save popover size in "saveValuesFromNodeTree" cb (visible popover will be rendered in componentDidUpdate)
            ReactDOM.render(React.createElement(ContextWrapper, { context: context }, hiddenPopover), _this.containerNode, _this.saveValuesFromNodeTree);
        };
        _this.removePopover = function () {
            if (_this.containerNode) {
                document.body.removeChild(_this.containerNode);
                _this.containerNode = null;
            }
        };
        _this.onPopoverOpenChange = function (props) {
            if (_this.isOpen(props)) {
                if (_this.isAbsolute()) {
                    _this.appendPopover();
                }
                _this.addListeners();
            }
            else {
                if (_this.isAbsolute()) {
                    _this.removePopover();
                }
                _this.removeListeners();
            }
        };
        _this.onPopoverStateChange = function () {
            var _a = _this.getPopoverProps(), onShow = _a.onShow, onHide = _a.onHide, onToggle = _a.onToggle;
            if (_this.state.isOpen) {
                onShow();
            }
            else {
                onHide();
            }
            onToggle();
            _this.onPopoverOpenChange();
        };
        _this.eventWrapper = function (cb) { return function (e) {
            if (_this.children) {
                var event_1 = _this.getPopoverProps().event;
                var childrenNode = _this.children.children[0];
                // It's safe to assume that the target is going to be a DOM Element
                // See also: https://stackoverflow.com/questions/28900077/why-is-event-target-not-element-in-typescript
                var el = e.target;
                if (_this.isAbsolute() || event_1 === 'hover' || _this.isEventInsideTarget(el, childrenNode)) {
                    cb(e);
                }
            }
        }; };
        _this.getDelayWhenClosed = function (delay) {
            return typeof delay === 'number' ? delay : (delay || {}).whenClosed;
        };
        _this.getDelayWhenOpen = function (delay) {
            return typeof delay === 'number' ? delay : (delay || {}).whenOpen;
        };
        _this.updateDebouncedMousedEvents = function (nextProps) {
            var delay = _this.getPopoverProps(nextProps).delay;
            var delayWhenClosed = _this.getDelayWhenClosed(delay);
            var delayWhenOpen = _this.getDelayWhenOpen(delay);
            var previousDelay = _this.getPopoverProps().delay;
            var previousDelayWhenClosed = _this.getDelayWhenClosed(previousDelay);
            var previousDelayWhenOpen = _this.getDelayWhenOpen(previousDelay);
            if (!nextProps || previousDelayWhenClosed !== delayWhenClosed) {
                _this.onMouseEventDebouncedWhenClosed = delayWhenClosed
                    ? debounce(_this._onMouseEvent, delayWhenClosed)
                    : null;
            }
            if (!nextProps || previousDelayWhenOpen !== delayWhenOpen) {
                _this.onMouseEventDebouncedWhenOpen = delayWhenOpen
                    ? debounce(_this._onMouseEvent, delayWhenOpen)
                    : null;
            }
        };
        _this._onMouseEvent = function (type) {
            if (type === 'mouseenter') {
                _this.showPopover();
            }
            else if (type === 'mouseleave') {
                _this.hidePopover();
            }
        };
        _this.onMouseEvent = function (_a) {
            var type = _a.type;
            var delay = _this.getPopoverProps().delay;
            var delayWhenClosed = _this.getDelayWhenClosed(delay);
            var delayWhenOpen = _this.getDelayWhenOpen(delay);
            if (_this.isOpen()) {
                return delayWhenOpen
                    ? _this.onMouseEventDebouncedWhenOpen && _this.onMouseEventDebouncedWhenOpen(type)
                    : _this._onMouseEvent(type);
            }
            else {
                return delayWhenClosed
                    ? _this.onMouseEventDebouncedWhenClosed && _this.onMouseEventDebouncedWhenClosed(type)
                    : _this._onMouseEvent(type);
            }
        };
        _this.showPopover = function () { return _this.setIsOpen(true); };
        _this.hidePopover = function () { return _this.setIsOpen(false); };
        _this.togglePopover = function () { return _this.setIsOpen(!_this.isOpen()); };
        _this.setIsOpen = function (isOpen) {
            if (_this.isStateful()) {
                _this.setState({ isOpen: isOpen }, _this.onPopoverStateChange);
            }
            else {
                var _a = _this.getPopoverProps(), onShow = _a.onShow, onHide = _a.onHide, onToggle = _a.onToggle, _isOpen = _a.isOpen;
                var cb = isOpen ? onShow : onHide;
                cb();
                if (_isOpen != isOpen) {
                    onToggle();
                }
            }
        };
        // LOCALES
        _this.popoverTemplate = function (_a) {
            var _computedAnchor = _a._computedAnchor, _computedPosition = _a._computedPosition, _style = __rest(_a, ["_computedAnchor", "_computedPosition"]);
            var _b = _this.getPopoverProps(), _position = _b.position, className = _b.className, _anchor = _b.anchor, content = _b.content, id = _b.id, event = _b.event, style = _b.style;
            var anchor = _computedAnchor || _anchor;
            var position = _computedPosition || _position;
            var _c = _this, eventWrapper = _c.eventWrapper, onMouseEvent = _c.onMouseEvent, isAbsolute = _c.isAbsolute;
            var positionClass = "position-".concat(position);
            var anchorClass = "anchor-".concat(anchor);
            var _className = "popover-content ".concat(positionClass, " ").concat(anchorClass, " ").concat(className);
            var events = !isAbsolute() && event === 'hover' ? { onMouseEnter: eventWrapper(onMouseEvent) } : undefined;
            return (React.createElement("div", __assign({ className: _className, id: id, style: __assign(__assign({}, style), _style) }, events), content));
        };
        _this.getVisiblePopover = function () {
            var popover = _this.state.popover;
            var popoverProps = _this.getPopoverProps();
            if (popoverProps.auto) {
                // give priority to the position passed by the user as _.uniq should maintain the order
                var positions = uniq([
                    popoverProps.position,
                    'top',
                    'bottom',
                    'left',
                    'right'
                ]);
                var popoverStyle = positions.reduce(function (acc, p) {
                    if (acc === null) {
                        // give priority to the couple position/anchor passed by the user as _.uniq should maintain the order
                        var anchors = uniq((p === popoverProps.position ? [popoverProps.anchor] : []).concat([
                            'center',
                            'start',
                            'end'
                        ]));
                        return anchors.reduce(function (workingPopoverStyle, a) {
                            if (workingPopoverStyle === null) {
                                var _popoverStyle = _this.computePopoverStyle(p, a);
                                // not enough space
                                if (typeof _popoverStyle.top === 'number' &&
                                    typeof _popoverStyle.left === 'number' &&
                                    (_popoverStyle.top < 0 ||
                                        _popoverStyle.top + popover.height > window.innerHeight ||
                                        _popoverStyle.left < 0 ||
                                        _popoverStyle.left + popover.width > window.innerWidth)) {
                                    return null;
                                }
                                return __assign(__assign({}, _popoverStyle), { _computedPosition: p, _computedAnchor: a });
                            }
                            return workingPopoverStyle;
                        }, null);
                    }
                    return acc;
                }, null);
                return _this.popoverTemplate(popoverStyle || _this.computePopoverStyle(popoverProps.position, popoverProps.anchor));
            }
            return _this.popoverTemplate(_this.computePopoverStyle(popoverProps.position, popoverProps.anchor));
        };
        _this.getHiddenPopover = function () {
            var style = {
                width: '100%',
                height: '100%',
                top: 0,
                left: 0,
                position: 'absolute',
                overflow: 'hidden',
                pointerEvents: 'none'
            };
            return (React.createElement("div", { id: NO_SIZE_WRAPPER, style: style }, _this.popoverTemplate({ position: 'absolute', visibility: 'hidden' })));
        };
        _this.isAbsolute = function () { return _this.getPopoverProps().attachToBody === true; };
        _this.getEventCallbacks = function () {
            var event = _this.getPopoverProps().event;
            var onHover = event === 'hover';
            var onClick = event === 'click';
            var _a = _this, eventWrapper = _a.eventWrapper, onMouseEvent = _a.onMouseEvent, togglePopover = _a.togglePopover;
            return {
                onMouseEnter: onHover ? eventWrapper(onMouseEvent) : undefined,
                onMouseLeave: onHover ? eventWrapper(onMouseEvent) : undefined,
                onClick: onClick ? eventWrapper(togglePopover) : undefined
            };
        };
        _this.computePopoverStyle = function (position, anchor) {
            var child = _this.state.child;
            var popover = _this.state.popover;
            var _a = _this.getPopoverProps(), maxWidth = _a.maxWidth, offsetX = _a.offsetX, offsetY = _a.offsetY, distance = _a.distance;
            var isAbsolute = _this.isAbsolute();
            var isHorizontal = position === 'top' || position === 'bottom';
            var isVertical = position === 'right' || position === 'left';
            var anchorOffset = { top: 0, left: 0 };
            var positionOffset = { top: 0, left: 0 };
            switch (position) {
                case 'top':
                    positionOffset.top = -(popover.height + distance);
                    break;
                case 'bottom':
                    positionOffset.top = child.height + distance;
                    break;
                case 'left':
                    positionOffset.left = -(popover.width + distance);
                    break;
                case 'right':
                    positionOffset.left = child.width + distance;
                    break;
            }
            switch (anchor) {
                case 'start':
                    // default -> { top: 0, left: 0 }
                    break;
                case 'center':
                    anchorOffset.left = isHorizontal ? (child.width - popover.width) / 2 : 0;
                    anchorOffset.top = isVertical ? (child.height - popover.height) / 2 : 0;
                    break;
                case 'end':
                    anchorOffset.left = isHorizontal ? child.width - popover.width : 0;
                    anchorOffset.top = isVertical ? child.height - popover.height : 0;
                    break;
            }
            return {
                position: 'absolute',
                top: (isAbsolute ? child.y : 0) + (positionOffset.top + anchorOffset.top + offsetY),
                left: (isAbsolute ? child.x : 0) + (positionOffset.left + anchorOffset.left + offsetX),
                maxWidth: maxWidth
            };
        };
        return _this;
    }
    Popover.prototype.componentDidMount = function () {
        this.ContextWrapper = (0, utils_1.getContextWrapper)(this.getPopoverProps().contextTypes);
        this.updateDebouncedMousedEvents();
        this.saveValuesFromNodeTree();
        this.initialized = true;
        if (this.isOpen()) {
            this.onPopoverOpenChange(this.props);
        }
    };
    Popover.prototype.componentDidUpdate = function (prevProps) {
        this.updateDebouncedMousedEvents(this.props);
        this.saveValuesFromNodeTree();
        var isOpenChanged = this.getPopoverProps(prevProps).isOpen !== this.getPopoverProps().isOpen;
        if (!this.isStateful() && isOpenChanged) {
            this.onPopoverOpenChange(this.props);
        }
        if (this.containerNode && this.state.popover) {
            var popover = this.getVisiblePopover();
            var context = this.getPopoverProps().context;
            var ContextWrapper = this.ContextWrapper;
            ReactDOM.render(React.createElement(ContextWrapper, { context: context }, popover), this.containerNode);
        }
    };
    Popover.prototype.componentWillUnmount = function () {
        this.removePopover();
        this.removeListeners();
        if (this.onMouseEventDebouncedWhenOpen) {
            this.onMouseEventDebouncedWhenOpen.cancel();
        }
        if (this.onMouseEventDebouncedWhenClosed) {
            this.onMouseEventDebouncedWhenClosed.cancel();
        }
    };
    Popover.prototype.getLocals = function () {
        var isRelative = !this.isAbsolute();
        var isOpen = this.isOpen();
        var popover = isRelative &&
            (this.initialized && isOpen ? this.getVisiblePopover() : this.getHiddenPopover());
        var style = __assign({ display: 'inline-block', position: isRelative ? 'relative' : undefined }, this.props.style);
        return __assign(__assign({}, this.props), { style: style, className: (0, classnames_1.default)('react-popover', this.props.className, {
                'is-open': isOpen,
                'is-closed': !isOpen
            }), eventCallbacks: this.getEventCallbacks(), popover: popover });
    };
    // RENDER
    Popover.prototype.render = function () {
        var _this = this;
        var _a = this.getLocals(), children = _a.children, style = _a.style, className = _a.className, id = _a.id, eventCallbacks = _a.eventCallbacks, popover = _a.popover;
        return (React.createElement("div", __assign({}, { id: id, className: className, style: style }, eventCallbacks, { ref: function (c) {
                _this.children = c;
            } }),
            children,
            popover));
    };
    return Popover;
}(React.Component));
exports.Popover = Popover;
