import * as React from 'react';
export type RadioOption<T> = {
    label: string;
    value: T;
};
export type RadioGroupRequiredProps<T> = {
    /** value */
    value?: T;
    /** onChange */
    onChange: (value: T) => void;
    getValueKey?: (value: T) => string;
    /** text displayed on the right of the checkbox */
    options: Array<RadioOption<T>>;
    className?: string;
    id?: string;
    style?: React.CSSProperties;
};
export type RadioGroupDefaultProps = {
    /** true if disabled */
    disabled: boolean;
    /** true if should layout options horizontally */
    horizontal: boolean;
};
export declare namespace RadioGroup {
    type Props<T> = RadioGroupRequiredProps<T> & Partial<RadioGroupDefaultProps>;
}
export declare class RadioGroup<T> extends React.PureComponent<RadioGroup.Props<T>> {
    static defaultProps: RadioGroupDefaultProps;
    onChange: (option: RadioOption<T>) => React.EventHandler<any>;
    render(): JSX.Element;
}
