"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.RadioGroup = void 0;
var React = __importStar(require("react"));
var classnames_1 = __importDefault(require("classnames"));
var react_flexview_1 = __importDefault(require("react-flexview"));
var RadioGroup = /** @class */ (function (_super) {
    __extends(RadioGroup, _super);
    function RadioGroup() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.onChange = function (option) {
            return function (e) {
                e.stopPropagation();
                if (!_this.props.disabled) {
                    _this.props.onChange(option.value);
                }
            };
        };
        return _this;
    }
    RadioGroup.prototype.render = function () {
        var _this = this;
        var _a = this.props, id = _a.id, className = _a.className, style = _a.style, disabled = _a.disabled, options = _a.options, value = _a.value, horizontal = _a.horizontal;
        var defaultedGetValueKey = this.props.getValueKey
            ? this.props.getValueKey
            : function (value) { return value; };
        return (React.createElement(react_flexview_1.default, { shrink: false, id: id, style: style, column: !horizontal, role: "radiogroup", className: (0, classnames_1.default)('radio-group', {
                'is-disabled': disabled,
                'is-horizontal': horizontal
            }, className) }, options.map(function (option) { return (React.createElement(react_flexview_1.default, { key: option.label, vAlignContent: "center", className: (0, classnames_1.default)('radio-group-option', {
                'is-checked': value && defaultedGetValueKey(option.value) === defaultedGetValueKey(value)
            }) },
            React.createElement("svg", { viewBox: "0 0 16 16", onClick: _this.onChange(option) },
                React.createElement("g", null,
                    React.createElement("circle", { className: "radio-group-circle-outer", cx: "8", cy: "8", r: "8" }),
                    React.createElement("circle", { className: "radio-group-circle", cx: "8", cy: "8", r: "7" }),
                    React.createElement("circle", { className: "radio-group-circle-inner", cx: "8", cy: "8", r: "5" }))),
            React.createElement(react_flexview_1.default, { className: "radio-group-label", onClick: _this.onChange(option) }, option.label))); })));
    };
    RadioGroup.defaultProps = {
        disabled: false,
        horizontal: false
    };
    return RadioGroup;
}(React.PureComponent));
exports.RadioGroup = RadioGroup;
