/// <reference types="react" />
export declare namespace ResizeSensor {
    type Props = {
        /** content */
        children: JSX.Element;
        /** called when a resize event is captured */
        onResize: () => void;
        /** callback delay (milliseconds) */
        debounce?: number;
    };
}
/**
 * A component that exposes an `onResize` callback called whenever his parent's size changes.
 */
export declare function ResizeSensor({ children, onResize, debounce }: ResizeSensor.Props): JSX.Element;
