"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ResizeSensor = void 0;
var react_resize_detector_1 = require("react-resize-detector");
/**
 * A component that exposes an `onResize` callback called whenever his parent's size changes.
 */
function ResizeSensor(_a) {
    var children = _a.children, onResize = _a.onResize, debounce = _a.debounce;
    (0, react_resize_detector_1.useResizeDetector)({
        onResize: onResize,
        refreshRate: debounce
    });
    return children;
}
exports.ResizeSensor = ResizeSensor;
