"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ScrollView = void 0;
var React = __importStar(require("react"));
var classnames_1 = __importDefault(require("classnames"));
var GeminiScrollbar = require("gemini-scrollbar");
var ResizeSensor_1 = require("../ResizeSensor/ResizeSensor");
var utils_1 = require("../utils");
/** A scrollable view to be used in projects where you want the same scrollbar style across different browsers */
var ScrollView = /** @class */ (function (_super) {
    __extends(ScrollView, _super);
    function ScrollView() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            isVerticalScrollbarVisible: false,
            isHorizontalScrollbarVisible: false
        };
        _this.scrollbar = null;
        _this.verticalThumb = null;
        _this.horizontalThumb = null;
        _this.wrapperRenderer = function (props) {
            var _a = props, children = _a.children, wrapperProps = __rest(_a, ["children"]);
            var component = _this.props.component;
            return React.createElement(component, wrapperProps, children);
        };
        _this.innerWrapperRenderer = function (props) {
            var _a = props, children = _a.children, innerWrapperProps = __rest(_a, ["children"]);
            var innerComponent = _this.props.innerComponent;
            return React.createElement(innerComponent, innerWrapperProps, children);
        };
        return _this;
    }
    ScrollView.prototype.componentDidMount = function () {
        var _a = this.props, autoshow = _a.autoshow, forceGemini = _a.forceGemini;
        this.scrollbar = new GeminiScrollbar({
            autoshow: autoshow,
            forceGemini: forceGemini,
            element: (0, utils_1.findDOMNode)(this),
            createElements: false
        }).create();
        this.saveScrollbarsState();
    };
    ScrollView.prototype.componentDidUpdate = function () {
        var scrollbar = this.scrollbar;
        var scrollTop = scrollbar.getViewElement().scrollTop;
        scrollbar.update();
        scrollbar.getViewElement().scrollTop = scrollTop;
        this.saveScrollbarsState();
    };
    ScrollView.prototype.componentWillUnmount = function () {
        this.scrollbar.destroy();
        this.scrollbar = null;
    };
    ScrollView.prototype.saveScrollbarsState = function () {
        var isVerticalScrollbarVisible = !!(this.verticalThumb &&
            this.verticalThumb.style.height &&
            this.verticalThumb.style.height !== '0px');
        var isHorizontalScrollbarVisible = !!(this.horizontalThumb &&
            this.horizontalThumb.style.width &&
            this.horizontalThumb.style.width !== '0px');
        if (this.state.isVerticalScrollbarVisible !== isVerticalScrollbarVisible ||
            this.state.isHorizontalScrollbarVisible !== isHorizontalScrollbarVisible) {
            this.setState({
                // eslint-disable-line react/no-did-update-set-state
                isVerticalScrollbarVisible: isVerticalScrollbarVisible,
                isHorizontalScrollbarVisible: isHorizontalScrollbarVisible
            });
        }
    };
    ScrollView.prototype.render = function () {
        var _this = this;
        var _a = this
            .props, componentProps = _a.componentProps, innerComponentProps = _a.innerComponentProps, className = _a.className, style = _a.style, children = _a.children;
        var _b = this.state, isVerticalScrollbarVisible = _b.isVerticalScrollbarVisible, isHorizontalScrollbarVisible = _b.isHorizontalScrollbarVisible;
        var _c = this, Wrapper = _c.wrapperRenderer, InnerWrapper = _c.innerWrapperRenderer;
        return (React.createElement(ResizeSensor_1.ResizeSensor, { onResize: function () { return _this.forceUpdate(); } },
            React.createElement(Wrapper, __assign({}, componentProps, { style: style, className: (0, classnames_1.default)('scrollview', className) }),
                React.createElement("div", { className: (0, classnames_1.default)('gm-scrollbar -vertical', {
                        visible: isVerticalScrollbarVisible
                    }) },
                    React.createElement("div", { className: "thumb", ref: function (ref) {
                            _this.verticalThumb = ref;
                        } })),
                React.createElement("div", { className: (0, classnames_1.default)('gm-scrollbar -horizontal', {
                        visible: isHorizontalScrollbarVisible
                    }) },
                    React.createElement("div", { className: "thumb", ref: function (ref) {
                            _this.horizontalThumb = ref;
                        } })),
                React.createElement("div", { className: "gm-scroll-view" },
                    React.createElement(ResizeSensor_1.ResizeSensor, { onResize: function () { return _this.forceUpdate(); } },
                        React.createElement(InnerWrapper, __assign({}, innerComponentProps), children))))));
    };
    ScrollView.defaultProps = {
        component: 'div',
        componentProps: {},
        forceGemini: true,
        innerComponent: 'div',
        innerComponentProps: {},
        style: {}
    };
    return ScrollView;
}(React.PureComponent));
exports.ScrollView = ScrollView;
