import * as React from 'react';
import { Children } from '../../utils';
export type Intrinsic<T, K> = {
    data: K extends keyof T ? T[K] : never;
    rowData: T;
    rowIndex: number;
    fixed: boolean;
    setState: any;
    forceUpdate: any;
    render: any;
};
export type Default = {
    vAlignContent: 'top' | 'center' | 'bottom';
    hAlignContent: 'left' | 'center' | 'right';
    grow: boolean;
};
export type Required<T, K> = {
    render: (data: K extends keyof T ? T[K] : never, rowData: T, rowIndex: number) => Children;
    backgroundColor?: React.CSSProperties['backgroundColor'];
    color?: React.CSSProperties['color'];
    contentStyle?: React.CSSProperties;
    style?: React.CSSProperties;
};
export declare namespace Cell {
    type Props<T, K extends keyof T | never> = Required<T, K> & Partial<Default>;
}
export type CellIntrinsicProps<T, K extends keyof T | never> = Cell.Props<T, K> & Intrinsic<T, K>;
export declare function Cell<T extends {}, K extends keyof T | never = never>(props: Cell.Props<T, K>): React.ReactElement<Cell.Props<T, K>>;
export declare const defaultCell: JSX.Element;
