import * as React from 'react';
import { Cell } from '../Cell/Cell';
import { Header } from '../Header/Header';
import Footer from '../Footer';
export type Intrinsic<T> = {
    data?: T[];
    sortDir?: 'asc' | 'desc';
    onHeaderClick: () => void;
};
export type Default = {
    width: number;
    allowCellsRecycling: boolean;
    fixed: boolean;
};
export type Required<T> = {
    key?: string | number;
    name: string;
    sortable?: boolean;
    isResizable?: boolean;
    flexGrow?: number;
    children?: Column.ColumnChildren<T>;
};
export declare namespace Column {
    type ColumnChildren<T> = (React.ReactElement<Header.Props> | React.ReactElement<Footer.Props> | React.ReactElement<Cell.Props<T, keyof T>>)[];
    type Props<T> = Required<T> & Partial<Default>;
}
export type ColumnDefaultedIntrinsicProps<T> = Required<T> & Default & Intrinsic<T>;
export type ColumnIntrinsicProps<T extends {}> = Column.Props<T> & Intrinsic<T>;
export declare const defaultWidth = 200;
export declare const Column: <T extends unknown>(args: Column.Props<T>) => React.ReactElement<Column.Props<T>, string | React.JSXElementConstructor<any>>;
export declare const defaultColumns: <T extends {}>(data: T[]) => React.ReactElement<Column.Props<T>, string | React.JSXElementConstructor<any>>[];
