"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.defaultColumns = exports.Column = exports.defaultWidth = void 0;
var React = __importStar(require("react"));
var find = require("lodash/find");
var utils_1 = require("../utils");
var fixed_data_table_2_1 = require("fixed-data-table-2");
var Cell_1 = require("../Cell/Cell");
var Header_1 = require("../Header/Header");
var Footer_1 = __importDefault(require("../Footer"));
exports.defaultWidth = 200;
var Column = function (args) {
    var _a = args, key = _a.key, _b = _a.width, width = _b === void 0 ? exports.defaultWidth : _b, flexGrow = _a.flexGrow, _c = _a.data, data = _c === void 0 ? [] : _c, name = _a.name, fixed = _a.fixed, isResizable = _a.isResizable, _d = _a.children, children = _d === void 0 ? [] : _d, _e = _a.allowCellsRecycling, allowCellsRecycling = _e === void 0 ? true : _e;
    var cell = function (_a) {
        var rowIndex = _a.rowIndex, columnKey = _a.columnKey;
        var elem = find((0, utils_1.getArrayChildren)(children), function (child) { return child.type === Cell_1.Cell; }) || Cell_1.defaultCell;
        var rowData = data[rowIndex] || {};
        var dataCell = rowData[columnKey || ''];
        return React.cloneElement(elem, {
            data: dataCell,
            rowData: rowData,
            rowIndex: rowIndex,
            fixed: fixed
        });
    };
    var header = React.cloneElement(find((0, utils_1.getArrayChildren)(children), function (child) { return child.type === Header_1.Header; }) || (0, Header_1.defaultHeader)(name), { fixed: fixed });
    var footer = find((0, utils_1.getArrayChildren)(children), function (child) { return child.type === Footer_1.default; }); // TODO onFooterClick
    return (React.createElement(fixed_data_table_2_1.Column, { key: key, columnKey: name, header: header, cell: cell, footer: footer, width: width, flexGrow: flexGrow, fixed: fixed, isResizable: isResizable, allowCellsRecycling: allowCellsRecycling }));
};
exports.Column = Column;
var defaultColumns = function (data) {
    return data.length > 0
        ? Object.keys(data[0]).map(function (columnName) {
            return (0, exports.Column)({ name: columnName });
        })
        : [];
};
exports.defaultColumns = defaultColumns;
