"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.updateColumns = exports.getColumnList = void 0;
var React = __importStar(require("react"));
var react_1 = require("react");
var curry = require("lodash/curry");
var flatMap = require("lodash/flatMap");
var Column_1 = require("./Column");
var ColumnGroup_1 = __importDefault(require("../ColumnGroup"));
var getColumnList = function (children) {
    var chArray = react_1.Children.toArray(children);
    var thereAreGroups = chArray.filter(function (ch) { return ch.type === ColumnGroup_1.default; }).length > 0;
    return thereAreGroups ? flatMap(chArray, function (ch) { return react_1.Children.toArray(ch.props.children); }) : chArray;
};
exports.getColumnList = getColumnList;
exports.updateColumns = curry(function (children, update) {
    var updateIfColumn = function (colGroup) { return function (col, index) { return (col.type === Column_1.Column ? update({ col: col, index: index, colGroup: colGroup }) : col); }; };
    var chArray = react_1.Children.toArray(children);
    var thereAreGroups = chArray.filter(function (ch) { return ch.type === ColumnGroup_1.default; }).length > 0;
    var newChildren = thereAreGroups
        ? chArray.map(function (group, key) {
            return React.cloneElement(group, {
                key: key,
                children: react_1.Children.map(group.props.children, updateIfColumn(group))
            });
        })
        : chArray.map(updateIfColumn());
    return newChildren;
});
