"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Tablo = void 0;
var React = __importStar(require("react"));
var classnames_1 = __importDefault(require("classnames"));
var fixed_data_table_2_1 = require("fixed-data-table-2");
var Column_1 = __importStar(require("./Column"));
var react_flexview_1 = __importDefault(require("react-flexview"));
var plugins_1 = require("./plugins");
var omit = require("lodash/omit");
var log_1 = require("../utils/log");
require("./patch-fixed-data-table-2");
var TabloComponent = /** @class */ (function (_super) {
    __extends(TabloComponent, _super);
    function TabloComponent() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    TabloComponent.prototype.render = function () {
        var _a = this
            .props, data = _a.data, children = _a.children, rcnGetter = _a.rowClassNameGetter, className = _a.className, _tableProps = __rest(_a, ["data", "children", "rowClassNameGetter", "className"]);
        var columnsOrGroups = (0, Column_1.updateColumns)(children || (0, Column_1.defaultColumns)(data), function (_a) {
            var col = _a.col;
            return React.createElement(Column_1.default, __assign({}, __assign(__assign({ key: col.props.name }, col.props), { data: data })));
        }).map(function (ch, key) { return ch.type(__assign({ key: key }, ch.props)); });
        if (columnsOrGroups.length !== [].concat(children || Object.keys(data[0])).length) {
            (0, log_1.warn)('There are extraneous children in the Grid. One should use only Column or ColumnGroup');
        }
        var rowClassNameGetter = function (index) {
            return (0, classnames_1.default)('tablo-row', { 'tablo-row-even': index % 2 === 0, 'tablo-row-odd': index % 2 === 1 }, rcnGetter(index));
        };
        var rowsCount = data.length;
        var tableProps = __assign(__assign({}, omit(_tableProps, ['columnsOrder', 'autosize'])), { rowsCount: rowsCount, rowClassNameGetter: rowClassNameGetter });
        return (React.createElement(react_flexview_1.default, { column: true, grow: true, className: (0, classnames_1.default)('tablo', className) },
            React.createElement(fixed_data_table_2_1.Table, __assign({}, tableProps), columnsOrGroups)));
    };
    TabloComponent.defaultProps = {
        rowClassNameGetter: function () { return ''; },
        rowHeight: 30,
        headerHeight: 40,
        groupHeaderHeight: 50,
        footerHeight: 0,
        autosize: true
    };
    return TabloComponent;
}(React.PureComponent));
var _Component = (0, plugins_1.autosize)((0, plugins_1.columnsResize)((0, plugins_1.columnsReorder)((0, plugins_1.scrollable)((0, plugins_1.selectable)((0, plugins_1.sortable)(TabloComponent))))));
function Tablo(props) {
    var Component = _Component;
    return React.createElement(Component, __assign({}, props));
}
exports.Tablo = Tablo;
