"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = __importStar(require("react"));
var classnames_1 = __importDefault(require("classnames"));
var react_dnd_1 = require("react-dnd");
var react_flexview_1 = __importDefault(require("react-flexview"));
var utils_1 = require("../../../utils");
var columnTarget = {
    canDrop: function (_a, monitor) {
        var isDropAllowed = _a.isDropAllowed, target = _a.name;
        if (monitor) {
            var source = monitor.getItem().name;
            return isDropAllowed(source, target);
        }
        else {
            return false;
        }
    },
    hover: function (_a, monitor, component) {
        var isDropAllowed = _a.isDropAllowed, onDragHover = _a.onDragHover, target = _a.name, hoverIndex = _a.index;
        if (monitor && component) {
            var item = monitor.getItem();
            var source = item.name;
            if (onDragHover && isDropAllowed(source, target)) {
                var hoverBoundingRect = (0, utils_1.findDOMNode)(component).getBoundingClientRect();
                var hoverMiddleX = (hoverBoundingRect.right - hoverBoundingRect.left) / 2;
                var clientOffset = monitor.getClientOffset();
                var hoverClientX = clientOffset.x - hoverBoundingRect.left;
                var dragIndex = item.index;
                if (dragIndex < hoverIndex && hoverClientX < hoverMiddleX) {
                    return;
                }
                if (dragIndex > hoverIndex && hoverClientX > hoverMiddleX) {
                    return;
                }
                onDragHover(source, target);
                item.index = hoverIndex;
            }
        }
    },
    drop: function (_a, monitor) {
        var isDropAllowed = _a.isDropAllowed, target = _a.name, onDrop = _a.onDrop;
        if (monitor) {
            var source = monitor.getItem().name;
            if (onDrop && isDropAllowed(source, target)) {
                onDrop(source, target);
            }
        }
    }
};
var collectTarget = function (connect, monitor) { return ({
    connectDropTarget: connect.dropTarget(),
    isOver: monitor.isOver(),
    canDrop: monitor.canDrop()
}); };
var columnSource = {
    beginDrag: function (_a) {
        var name = _a.name, index = _a.index;
        return { name: name, index: index };
    },
    isDragging: function (_a, monitor) {
        var name = _a.name;
        if (!monitor)
            return false;
        return name === monitor.getItem().name;
    },
    canDrag: function (_a) {
        var isDragAllowed = _a.isDragAllowed;
        return isDragAllowed;
    }
};
var collectSource = function (connect, monitor) {
    return {
        connectDragSource: connect.dragSource(),
        connectDragPreview: connect.dragPreview(),
        isDragging: monitor.isDragging()
    };
};
var columnType = function (_a) {
    var tabloUniqueId = _a.tabloUniqueId;
    return "".concat(tabloUniqueId, "_column");
};
var DNDHeader = /** @class */ (function (_super) {
    __extends(DNDHeader, _super);
    function DNDHeader() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    DNDHeader.prototype.render = function () {
        var _a = this.props, connectDragSource = _a.connectDragSource, connectDropTarget = _a.connectDropTarget, isDragAllowed = _a.isDragAllowed, isDragging = _a.isDragging, canDrop = _a.canDrop, isOver = _a.isOver, children = _a.children;
        var header = (React.createElement("div", { className: (0, classnames_1.default)('dndHeader', { isDragging: isDragging, canDrop: canDrop, isOver: isOver }) },
            React.createElement(react_flexview_1.default, { vAlignContent: "center", width: "100%", height: "100%" },
                React.createElement(react_flexview_1.default, { grow: true, height: "100%", vAlignContent: "center" }, children))));
        return isDragAllowed ? connectDropTarget(connectDragSource(header)) : header;
    };
    DNDHeader = __decorate([
        (0, react_dnd_1.DragSource)(columnType, columnSource, collectSource),
        (0, react_dnd_1.DropTarget)(columnType, columnTarget, collectTarget)
    ], DNDHeader);
    return DNDHeader;
}(React.PureComponent));
exports.default = DNDHeader;
