"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = __importStar(require("react"));
var utils_1 = require("../../../utils");
var classnames_1 = __importDefault(require("classnames"));
var sortBy = require("lodash/sortBy");
var findIndex = require("lodash/findIndex");
var once = require("lodash/once");
var uniqueId = require("lodash/uniqueId");
var htmlBackend_1 = __importDefault(require("./htmlBackend"));
var Column_1 = __importStar(require("../../Column"));
var ColumnGroup_1 = __importDefault(require("../../ColumnGroup"));
var Header_1 = __importStar(require("../../Header"));
var DNDHeader_1 = __importDefault(require("./DNDHeader"));
var utils_2 = require("../../utils");
exports.default = (function (Grid) {
    var ColumnsReorderGrid = /** @class */ (function (_super) {
        __extends(ColumnsReorderGrid, _super);
        function ColumnsReorderGrid(props) {
            var _this = _super.call(this, props) || this;
            _this.uniqueId = uniqueId('tablo_');
            return _this;
        }
        ColumnsReorderGrid.prototype.getLocals = function (_a) {
            var _this = this;
            var className = _a.className, children = _a.children, _b = _a.columnsOrder, columnsOrder = _b === void 0 ? [] : _b, onColumnsReorder = _a.onColumnsReorder, gridProps = __rest(_a, ["className", "children", "columnsOrder", "onColumnsReorder"]);
            var _children = (0, utils_2.getArrayChildren)(children) || (0, Column_1.defaultColumns)(gridProps.data);
            var thereAreGroups = _children.filter(function (c) { return c.type === ColumnGroup_1.default; }).length > 0;
            if (thereAreGroups || !onColumnsReorder) {
                return __assign({ 
                    // no reordering of columns if there are groups
                    className: className, children: _children }, gridProps);
            }
            var doOrderColumns = function (child) {
                if (child.type === Header_1.default) {
                    return -1;
                }
                var index = findIndex(columnsOrder, function (n) { return n === child.props.name; });
                return index === -1 ? Infinity : index;
            };
            var orderedChildren = sortBy(_children, doOrderColumns);
            var moveColumn = function (list, source, target) {
                if (list === void 0) { list = []; }
                var source_index = list.indexOf(source);
                var target_index = list.indexOf(target);
                if (source_index <= target_index) {
                    return __spreadArray(__spreadArray(__spreadArray(__spreadArray([], list.slice(0, source_index), true), list.slice(source_index + 1, target_index + 1), true), [
                        source
                    ], false), list.slice(target_index + 1), true);
                }
                else {
                    return __spreadArray(__spreadArray(__spreadArray(__spreadArray([], list.slice(0, target_index), true), [
                        source
                    ], false), list.slice(target_index, source_index), true), list.slice(source_index + 1), true);
                }
            };
            var onColumnsSwitch = function (sourceName, targetName) {
                if (onColumnsReorder && sourceName && targetName && sourceName !== targetName) {
                    var newColumnsOrder = moveColumn(orderedChildren.map(function (c) { return c.props.name; }), sourceName, targetName);
                    return onColumnsReorder(newColumnsOrder);
                }
                return undefined;
            };
            var isDragAllowed = function (_a) {
                var fixed = _a.props.fixed;
                return !fixed;
            };
            var isDropAllowed = function (fixed) { return function (source, target) {
                return !fixed && source !== target;
            }; };
            var overrideHeader = function (_a) {
                var col = _a.col, index = _a.index;
                var _b = col.props, name = _b.name, fixed = _b.fixed;
                var header = (0, utils_1.find)((0, utils_2.getArrayChildren)(col.props.children), function (child) { return child.type === Header_1.default; }) ||
                    (0, Header_1.defaultHeader)(col.props.name);
                var otherChildren = ((0, utils_2.getArrayChildren)(col.props.children) || []).filter(function (ch) { return ch.type !== Header_1.default; });
                var oncedOnColumnsSwitch = once(onColumnsSwitch);
                var dndHeader = (React.createElement(Header_1.default, __assign({}, header.props),
                    React.createElement(DNDHeader_1.default, { onDragHover: oncedOnColumnsSwitch, key: index, index: index, name: name, isDragAllowed: isDragAllowed(col), isDropAllowed: isDropAllowed(!!fixed), tabloUniqueId: _this.uniqueId }, header.props.children)));
                var children = __spreadArray([dndHeader], otherChildren, true).map(function (el, index) {
                    return React.cloneElement(el, { key: index });
                });
                var Col = Column_1.default;
                return (React.createElement(Col, __assign({}, col.props, { key: name }), children));
            };
            var __children = (0, Column_1.updateColumns)(orderedChildren, overrideHeader);
            return __assign({ className: (0, classnames_1.default)('columns-reorderable-tablo', className), children: __children }, gridProps);
        };
        ColumnsReorderGrid.prototype.render = function () {
            return React.createElement(Grid, __assign({}, this.getLocals(this.props)));
        };
        return ColumnsReorderGrid;
    }(React.PureComponent));
    return (0, htmlBackend_1.default)(ColumnsReorderGrid);
});
