"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.clean = void 0;
var React = __importStar(require("react"));
var classnames_1 = __importDefault(require("classnames"));
var omitBy = require("lodash/omitBy");
var Column_1 = require("../../Column");
var columnSortable_1 = __importDefault(require("./columnSortable"));
var ColumnGroup_1 = __importDefault(require("../../ColumnGroup"));
var utils_1 = require("../../utils");
var clean = function (columnProps) { return omitBy(columnProps, function (x) { return typeof x === 'undefined'; }); };
exports.clean = clean;
var getLocals = function (_a) {
    var className = _a.className, sortBy = _a.sortBy, sortDir = _a.sortDir, onSortChange = _a.onSortChange, children = _a.children, gridProps = __rest(_a, ["className", "sortBy", "sortDir", "onSortChange", "children"]);
    var nextSort = function (newSortBy) {
        var prevSortDir = newSortBy === sortBy ? sortDir : undefined;
        var newSortDir = (function () {
            switch (prevSortDir) {
                case 'asc':
                    return 'desc';
                case 'desc':
                    return undefined;
                default:
                    return 'asc';
            }
        })();
        return {
            sortBy: newSortDir ? newSortBy : undefined,
            sortDir: newSortDir
        };
    };
    var onHeaderClick = function (columnKey) { return function () {
        if (!onSortChange) {
            return;
        }
        var _a = nextSort(columnKey), sortBy = _a.sortBy, sortDir = _a.sortDir;
        onSortChange({ sortBy: sortBy, sortDir: sortDir });
    }; };
    var _children = (0, utils_1.getArrayChildren)(children) || (0, Column_1.defaultColumns)(gridProps.data);
    var addSortableProps = function (_a) {
        var col = _a.col, colGroup = _a.colGroup;
        var colGroupSortable = colGroup ? colGroup.props.sortable : undefined;
        return (0, columnSortable_1.default)((0, exports.clean)(__assign(__assign({ key: col.props.name, sortable: typeof colGroupSortable !== 'undefined' ? colGroupSortable : !!onSortChange }, col.props), { onHeaderClick: onHeaderClick(col.props.name), sortDir: sortBy === col.props.name || col.type === ColumnGroup_1.default ? sortDir : undefined })));
    };
    var __children = (0, Column_1.updateColumns)(_children, addSortableProps);
    return __assign({ className: (0, classnames_1.default)('sortable-tablo', className), children: __children }, gridProps);
};
exports.default = (function (Grid) {
    return /** @class */ (function (_super) {
        __extends(SortableGrid, _super);
        function SortableGrid() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        SortableGrid.prototype.render = function () {
            return React.createElement(Grid, __assign({}, getLocals(this.props)));
        };
        return SortableGrid;
    }(React.PureComponent));
});
