"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TextOverflow = void 0;
var React = __importStar(require("react"));
var omit = require("lodash/omit");
var debounce = require("lodash/debounce");
var log_1 = require("../utils/log");
var ResizeSensor_1 = require("../ResizeSensor/ResizeSensor");
var Popover_1 = require("../Popover/Popover");
/**
 * Text view which, if string content is too large, trims it and shows the full content on "hover".
 */
var TextOverflow = /** @class */ (function (_super) {
    __extends(TextOverflow, _super);
    function TextOverflow() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.text = null;
        _this.textWithoutEllipsis = null;
        _this.state = { isOverflowing: false, isHovering: false };
        _this.reset = function () {
            return _this.setState({
                isOverflowing: false
            }, function () { return _this.verifyOverflow({ force: true, reset: true }); });
        };
        _this.logWarnings = function () {
            (0, log_1.warn)(function () {
                var node = _this.text;
                if (node) {
                    var styleNode = node.parentElement.parentElement;
                    var _a = styleNode.style, width = _a.width, flex = _a.flex;
                    var flexBasis = flex ? flex.split(' ')[2] : null;
                    if (width !== '100%' && flexBasis !== '100%') {
                        return [
                            'WARNING: TextOverflow\'s parent doesn\'t have "width: 100%" nor "flex-basis: 100%"',
                            styleNode
                        ];
                    }
                }
                return undefined;
            });
        };
        _this.getElementWidth = function (element) {
            if (element && typeof window !== 'undefined') {
                var width = window.getComputedStyle(element).width;
                return width ? parseFloat(width) : 0;
            }
            return 0;
        };
        _this.verifyOverflow = function (_a) {
            var _b = _a === void 0 ? {} : _a, force = _b.force, reset = _b.reset;
            if ((force || (!_this.props.lazy && _this.state.isOverflowing === false)) &&
                typeof window !== 'undefined') {
                var text = _this.text;
                var textWithoutEllipsis = _this.textWithoutEllipsis;
                if (text && textWithoutEllipsis) {
                    var textWidth = _this.getElementWidth(text);
                    var textWithoutEllipsisWidth = _this.getElementWidth(textWithoutEllipsis);
                    var isOverflowing = textWidth < textWithoutEllipsisWidth;
                    if (isOverflowing && !_this.state.isOverflowing) {
                        _this.setState({ isOverflowing: true }, _this.logWarnings);
                    }
                    else if (!isOverflowing && reset && _this.state.isOverflowing) {
                        _this.setState({ isOverflowing: false }, _this.logWarnings);
                    }
                    else {
                        _this.logWarnings();
                    }
                }
            }
        };
        _this._onMouseEvent = function (type) { return type === 'mouseenter' && _this.onMouseEnter(); };
        _this.onMouseEventDebounced = debounce(_this._onMouseEvent, _this.props.delayWhenLazy);
        _this.onMouseEvent = function (_a) {
            var type = _a.type;
            _this.props.delayWhenLazy ? _this.onMouseEventDebounced(type) : _this._onMouseEvent(type);
        };
        _this.onMouseEnter = function () {
            if (!_this.state.isHovering) {
                _this.setState({
                    isHovering: true
                }, function () { return _this.props.lazy && _this.verifyOverflow({ force: true, reset: true }); });
            }
        };
        _this.onMouseLeave = function () {
            _this.state.isHovering && _this.setState({ isHovering: false });
        };
        _this.onResize = function () { return _this.verifyOverflow({ force: true, reset: true }); };
        _this.getContent = function () {
            var _a = _this, onMouseEvent = _a.onMouseEvent, onMouseLeave = _a.onMouseLeave, _b = _a.props, label = _b.label, lazy = _b.lazy;
            var styleText = {
                display: 'block',
                whiteSpace: 'nowrap',
                width: '100%',
                overflow: 'hidden',
                OTextOverflow: 'ellipsis',
                textOverflow: 'ellipsis'
            };
            var styleTextWithoutEllipsis = {
                position: 'fixed',
                visibility: 'hidden',
                pointerEvents: 'none',
                top: 0,
                left: 0
            };
            var events = lazy && {
                onMouseEnter: onMouseEvent,
                onMouseLeave: function (e) {
                    onMouseEvent(e);
                    onMouseLeave(e);
                }
            };
            var text = (React.createElement("span", __assign({ ref: function (t) {
                    _this.text = t;
                } }, events, { style: styleText }), label));
            return (React.createElement("div", null,
                lazy ? text : React.createElement(ResizeSensor_1.ResizeSensor, { onResize: _this.onResize }, text),
                React.createElement("span", { ref: function (t) {
                        _this.textWithoutEllipsis = t;
                    }, style: styleTextWithoutEllipsis }, label)));
        };
        _this.templateOverflow = function () {
            var isHovering = _this.state.isHovering;
            var _a = _this
                .props, children = _a.children, label = _a.label, style = _a.style, lazy = _a.lazy, popoverProps = _a.popover, other = __rest(_a, ["children", "label", "style", "lazy", "popover"]);
            if (children) {
                return React.createElement(React.Fragment, null, children(_this.getContent(), lazy ? isHovering : undefined));
            }
            else {
                var content = label;
                var popover = __assign(__assign({}, popoverProps), { content: content, event: 'hover', isOpen: lazy ? isHovering : undefined });
                var props = __assign(__assign({}, omit(other, ['delayWhenLazy'])), { popover: popover, style: __assign({ width: '100%' }, style) });
                return React.createElement(Popover_1.Popover, __assign({}, props), _this.getContent());
            }
        };
        _this.templeteStandard = function () {
            var _a = _this.props, style = _a.style, other = __rest(_a, ["style"]);
            var props = __assign(__assign({}, omit(other, ['children', 'label', 'lazy', 'delayWhenLazy', 'popover'])), { style: __assign({ width: '100%' }, style) });
            return React.createElement("div", __assign({}, props), _this.getContent());
        };
        return _this;
    }
    TextOverflow.prototype.componentDidMount = function () {
        !this.props.lazy && this.verifyOverflow();
    };
    TextOverflow.prototype.componentDidUpdate = function (prevProps) {
        if (!prevProps.lazy && this.props.label !== prevProps.label) {
            this.reset();
        }
    };
    TextOverflow.prototype.render = function () {
        return this.state.isOverflowing ? this.templateOverflow() : this.templeteStandard();
    };
    TextOverflow.defaultProps = {
        delayWhenLazy: 100,
        lazy: false
    };
    return TextOverflow;
}(React.Component));
exports.TextOverflow = TextOverflow;
