import * as React from 'react';
import { ObjectOverwrite } from '../utils';
import TextareaAutosize from 'react-autosize-textarea';
export type TextareaRequiredProps = ObjectOverwrite<TextareaAutosize.Props, {
    /** value */
    value: string;
    /** onChange */
    onChange: (value: string) => void;
    /** don't use this. Use `innerRef` instead */
    ref?: never;
}>;
export type TextareaDefaultProps = {
    /** true if disabled */
    disabled: boolean;
};
export declare namespace Textarea {
    type Props = TextareaRequiredProps & Partial<TextareaDefaultProps>;
}
export declare class Textarea extends React.PureComponent<Textarea.Props> {
    static defaultProps: TextareaDefaultProps;
    _onChange: React.ChangeEventHandler<HTMLTextAreaElement>;
    render(): JSX.Element;
}
