"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.makeOptions = exports.filterTime = exports.createTimeList = exports.parseInTimeFormat = exports.toOption = exports.TimePicker = exports.inputError = exports.H12 = exports.H24 = void 0;
var React = __importStar(require("react"));
var classnames_1 = __importDefault(require("classnames"));
var Dropdown_1 = require("../Dropdown");
var range = require("lodash/range");
var flatten = require("lodash/flatten");
var compact = require("lodash/compact");
var uniqBy = require("lodash/uniqBy");
var sortBy = require("lodash/sortBy");
var react_select_1 = require("react-select");
var find = require("lodash/find");
var log_1 = require("../utils/log");
exports.H24 = '24h';
exports.H12 = '12h';
exports.inputError = {};
var symbolRegex = /[\s,\-\+\.\|\/\\]/;
var numberRegex = /^\d+$/;
var separator = ':';
var interval = 30;
var pad = function (num) { return (num <= 9 ? "0".concat(num) : num); };
var normalizeHoursToH24 = function (hour) { return (hour + 12 !== 24 ? hour + 12 : 0); };
var lteTime = function (minTime, maxTime) {
    return maxTime.hours > minTime.hours ||
        (maxTime.hours === minTime.hours && maxTime.minutes >= minTime.minutes);
};
var isInteger = function (n) { return n % 1 === 0; };
var isHour = function (n) { return isInteger(n) && n >= 0 && n <= 23; };
var isHour12 = function (n) { return isInteger(n) && n >= 0 && n <= 12; };
var isMinute = function (n) { return isInteger(n) && n >= 0 && n <= 59; };
var isTime = function (time) {
    return time != null && isHour(time.hours) && isMinute(time.minutes);
};
var isValidHoursInTimeFormat = function (hours, timeFormat) {
    return hours == null ? false : timeFormat === exports.H24 ? isHour(hours) : isHour12(hours);
};
var getComponents = function (timeFormatter) {
    return timeFormatter
        ? {
            Option: function (props) { return (React.createElement(react_select_1.components.Option, __assign({}, props), timeFormatter(props.data.time))); },
            SingleValue: function (props) { return timeFormatter(props.data.time); }
        }
        : {};
};
function validProps(_a) {
    var value = _a.value, minTime = _a.minTime, maxTime = _a.maxTime;
    var validTimes = (value == null || isTime(value)) &&
        (minTime == null || isTime(minTime)) &&
        (maxTime == null || isTime(maxTime));
    var minMaxCoherent = minTime == null || maxTime == null || lteTime(minTime, maxTime);
    var valueMoreThanMin = value == null || minTime == null || lteTime(minTime, value);
    var valueLessThanMax = value == null || maxTime == null || lteTime(value, maxTime);
    return validTimes && minMaxCoherent && valueMoreThanMin && valueLessThanMax;
}
var formatTime24 = function (_a) {
    var hours = _a.hours, minutes = _a.minutes;
    return "".concat(pad(hours), ":").concat(pad(minutes));
};
var formatTime12 = function (_a) {
    var hours = _a.hours, minutes = _a.minutes;
    if (hours === 0 || (hours > 12 && hours % 12 === 0)) {
        return "12".concat(separator).concat(pad(minutes), " am");
    }
    else if (hours === 12) {
        return "12".concat(separator).concat(pad(minutes), " pm");
    }
    else if (hours >= 13) {
        return "".concat(pad(hours % 12)).concat(separator).concat(pad(minutes), " pm");
    }
    else {
        return "".concat(pad(hours)).concat(separator).concat(pad(minutes), " am");
    }
};
var formatTime = function (_a) {
    var hours = _a.hours, minutes = _a.minutes, timeFormat = _a.timeFormat;
    return timeFormat === exports.H12 ? formatTime12({ hours: hours, minutes: minutes }) : formatTime24({ hours: hours, minutes: minutes });
};
var toOption = function (time) { return ({
    time: time,
    value: formatTime24(time),
    label: formatTime(time)
}); };
exports.toOption = toOption;
var cleanSeparator = function (str) { return str.replace(symbolRegex, separator); };
var maybeAddTrailingZero = function (str) {
    if (str.length === 4) {
        return "".concat(str, "0");
    }
    else {
        return str;
    }
};
var maybeInsertSeparator = function (str) {
    if (numberRegex.test(str)) {
        if (str.length === 3) {
            var position = str.length - 1;
            var strWithColon = "".concat(str.substr(0, position)).concat(separator).concat(str.substr(position));
            return strWithColon;
        }
        else if (str.length === 4) {
            var position = str.length - 2;
            var strWithColon = "".concat(str.substr(0, position)).concat(separator).concat(str.substr(position));
            return strWithColon;
        }
    }
    return str;
};
var parseInTimeFormat = function (inputStr, timeFormat) {
    if (inputStr === '') {
        return { originalInput: inputStr };
    }
    var cleanedInput = maybeAddTrailingZero(maybeInsertSeparator(cleanSeparator(inputStr)));
    var inputArray = cleanedInput.split(separator);
    var _hours = inputArray[0], _minutes = inputArray[1];
    var hours = numberRegex.test(_hours) ? parseInt(_hours, 10) : null;
    var minutes = !_minutes || numberRegex.test(_minutes) ? parseInt(_minutes, 10) : null;
    if (isValidHoursInTimeFormat(hours, timeFormat) && minutes != null && isMinute(minutes)) {
        return { hours: hours, minutes: minutes, originalInput: cleanedInput };
    }
    else if (isValidHoursInTimeFormat(hours, timeFormat)) {
        return { originalInput: cleanedInput };
    }
    else {
        return exports.inputError;
    }
};
exports.parseInTimeFormat = parseInTimeFormat;
var createTimeList = function (_a, timeFormat) {
    var hours = _a.hours, minutes = _a.minutes;
    if (!isValidHoursInTimeFormat(hours, timeFormat) || !minutes || !isMinute(minutes)) {
        var hoursList = range(0, 24);
        var minutesList_1 = range(0, 60, interval);
        return flatten(hoursList.map(function (hours) { return minutesList_1.map(function (minutes) { return ({ hours: hours, minutes: minutes, timeFormat: timeFormat }); }); }));
    }
    else {
        return timeFormat !== exports.H24
            ? [
                { hours: hours, minutes: minutes, timeFormat: timeFormat },
                { hours: normalizeHoursToH24(hours), minutes: minutes, timeFormat: timeFormat }
            ]
            : [{ hours: hours, minutes: minutes, timeFormat: timeFormat }];
    }
};
exports.createTimeList = createTimeList;
var startsWith = function (time, originalInput) {
    var timeStr = formatTime(time);
    return timeStr.substr(0, originalInput.length) === originalInput;
};
var filterTime = function (_a) {
    var originalInput = _a.originalInput, minTime = _a.minTime, maxTime = _a.maxTime;
    return function (time) {
        return lteTime(minTime, time) && lteTime(time, maxTime) && startsWith(time, originalInput);
    };
};
exports.filterTime = filterTime;
var makeOptions = function (_a, inputValue) {
    var minTime = _a.minTime, maxTime = _a.maxTime, timeFormat = _a.timeFormat, userValue = _a.userValue;
    var time = parseInTimeFormat(inputValue, timeFormat);
    var selectedValue = userValue && userValue !== exports.inputError ? __assign(__assign({}, userValue), { timeFormat: timeFormat }) : userValue;
    var timeList = (time === exports.inputError
        ? []
        : createTimeList(time, timeFormat)).concat(compact([selectedValue]));
    var filteredTimeList = timeList.filter(filterTime({
        originalInput: time.originalInput || '',
        minTime: minTime,
        maxTime: maxTime // TODO(typo)
    }));
    return uniqBy(sortBy(filteredTimeList.map(toOption), 'value'), 'value');
};
exports.makeOptions = makeOptions;
var TimePicker = /** @class */ (function (_super) {
    __extends(TimePicker, _super);
    function TimePicker() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = { inputValue: '' };
        _this._onChange = function (value) {
            // interface with component user is always in H24
            var time = parseInTimeFormat(value.value, exports.H24);
            _this.props.onChange(time);
        };
        _this.updateInputValue = function (inputValue) { return _this.setState({ inputValue: inputValue }); };
        return _this;
    }
    TimePicker.prototype.componentDidMount = function () {
        if (process.env.NODE_ENV !== 'production') {
            if (!validProps(this.props)) {
                (0, log_1.warn)('Invalid props provided: `value`, `minTime` or `maxTime` are not valid times or not coherent');
            }
        }
    };
    TimePicker.prototype.render = function () {
        var _this = this;
        var _a = this.props, _className = _a.className, id = _a.id, minTime = _a.minTime, maxTime = _a.maxTime, timeFormat = _a.timeFormat, userValue = _a.value, searchable = _a.searchable, size = _a.size, placeholder = _a.placeholder, menuPosition = _a.menuPosition, disabled = _a.disabled, timeFormatter = _a.timeFormatter, userComponents = _a.components;
        var value = userValue ? formatTime24(userValue) : undefined;
        var options = makeOptions({ minTime: minTime, maxTime: maxTime, timeFormat: timeFormat, userValue: userValue }, this.state.inputValue);
        var className = (0, classnames_1.default)('time-picker', _className);
        var onChange = this._onChange;
        var updateInputValue = this.updateInputValue;
        var computedComponents = getComponents(timeFormatter);
        return (React.createElement(Dropdown_1.SingleDropdown, { id: id, className: className, isSearchable: searchable, value: find(options, function (o) { return o.value === value; }), onChange: onChange, options: options, components: __assign(__assign({}, computedComponents), userComponents), placeholder: placeholder, size: size, onInputChange: updateInputValue, onBlur: function () { return _this.forceUpdate(); }, menuPlacement: menuPosition, isDisabled: disabled }));
    };
    TimePicker.defaultProps = {
        placeholder: "--".concat(separator, "--"),
        timeFormat: exports.H24,
        minTime: { hours: 0, minutes: 0 },
        maxTime: { hours: 23, minutes: 59 },
        searchable: true,
        size: 'medium',
        menuPosition: 'bottom'
    };
    return TimePicker;
}(React.Component));
exports.TimePicker = TimePicker;
