"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Toaster = void 0;
var React = __importStar(require("react"));
var ReactDOM = __importStar(require("react-dom"));
var classnames_1 = __importDefault(require("classnames"));
var TransitionGroup_1 = __importDefault(require("react-transition-group/TransitionGroup"));
var utils_1 = require("../utils");
var log_1 = require("../utils/log");
var TransitionWrapper_1 = require("../TransitionWrapper/TransitionWrapper");
/**
 * Renders and animates toasts (children) inline or in a portal
 */
var Toaster = /** @class */ (function (_super) {
    __extends(Toaster, _super);
    function Toaster() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.toaster = null;
        _this.getToasts = function () {
            var _a = _this.props, children = _a.children, transitionStyles = _a.transitionStyles, transitionEnterTimeout = _a.transitionEnterTimeout, transitionLeaveTimeout = _a.transitionLeaveTimeout;
            return React.Children.map(children, function (_el, i) {
                var el = _el;
                return (React.createElement(TransitionWrapper_1.TransitionWrapper, __assign({}, {
                    transitionStyles: transitionStyles,
                    transitionEnterTimeout: transitionEnterTimeout,
                    transitionLeaveTimeout: transitionLeaveTimeout
                }, { style: _this.getTranslationStyle(i), key: el.key || undefined }), React.cloneElement(el, { uniqueKey: el.key })));
            });
        };
        _this.appendToaster = function () {
            if (_this.props.attachTo) {
                _this.toaster = document.getElementById(_this.props.attachTo);
            }
        };
        _this.removeToaster = function () {
            if (_this.toaster && _this.props.attachTo) {
                _this.toaster.innerHTML = ''; // stupid??
            }
        };
        _this.getToaster = function () {
            var _a = _this.props, styleProp = _a.style, id = _a.id, className = _a.className, position = _a.position;
            var isTop = position.indexOf('top') !== -1;
            var isRight = position.indexOf('right') !== -1;
            var style = __assign({ position: 'absolute', right: isRight ? 0 : undefined, left: isRight ? undefined : 0, bottom: isTop ? undefined : 0, top: isTop ? 0 : undefined, height: '100%' }, styleProp);
            return (React.createElement("div", __assign({ className: (0, classnames_1.default)('toaster', className) }, { style: style, id: id }),
                React.createElement(TransitionGroup_1.default, __assign({}, _this.props.transitionGroup), _this.getToasts())));
        };
        _this.renderToaster = function () {
            if (_this.props.attachTo) {
                ReactDOM.render(_this.getToaster(), _this.toaster);
            }
        };
        return _this;
    }
    Toaster.prototype.componentWillMount = function () {
        this.appendToaster();
        this.renderToaster();
    };
    Toaster.prototype.componentDidMount = function () {
        var node = this.props.attachTo ? this.toaster : (0, utils_1.findDOMNode)(this).parentElement;
        var position = window.getComputedStyle(node).position;
        if (position !== 'relative' && position !== 'absolute') {
            (0, log_1.warn)(['Toaster\'s parent node should have "position: relative/absolute"', node]);
        }
    };
    Toaster.prototype.componentWillUnmount = function () {
        this.removeToaster();
    };
    Toaster.prototype.getTranslationStyle = function (i) {
        var position = this.props.position;
        var isTop = position.indexOf('top') !== -1;
        var isRight = position.indexOf('right') !== -1;
        var translationBase = isTop ? 100 : -100;
        return {
            transform: "translateY(".concat(translationBase * i, "%)"),
            position: 'absolute',
            right: isRight ? 0 : undefined,
            left: isRight ? undefined : 0,
            bottom: isTop ? undefined : 0,
            top: isTop ? 0 : undefined
        };
    };
    Toaster.prototype.render = function () {
        if (this.props.attachTo) {
            return null;
        }
        else {
            return this.getToaster();
        }
    };
    Toaster.prototype.componentDidUpdate = function (prevProps) {
        if (prevProps.attachTo !== this.props.attachTo) {
            (0, log_1.warn)('You can\'t change "attachTo" prop after the first render!');
        }
        this.renderToaster();
    };
    Toaster.defaultProps = {
        transitionGroup: {},
        position: 'top-right'
    };
    return Toaster;
}(React.Component));
exports.Toaster = Toaster;
