import * as React from 'react';
export type ToggleDefaultProps = {};
export type ToggleRequiredProps = {
    /** the current value (`true` if checked) */
    value: boolean;
    /** callback called when user clicks on the Toggle */
    onChange: (value: boolean) => void;
    /** disable the onClick callback and renders with reduced opacity */
    disabled?: boolean;
    /** The size for the Toggle in whatever unit (px, em, rem ...). It will be used to compute `width`, `height` and `border-radius` as follows: `width: size`, `height: size / 2`, `border-radius: size / 2` */
    size?: number | string;
    /** called when the input is focused */
    onFocus?: React.FocusEventHandler<HTMLInputElement>;
    /** called when the input is blurred */
    onBlur?: React.FocusEventHandler<HTMLInputElement>;
    className?: string;
    style?: React.CSSProperties;
};
export declare namespace Toggle {
    type Props = ToggleRequiredProps & Partial<ToggleDefaultProps>;
}
type ToggleDefaultedProps = ToggleRequiredProps & ToggleDefaultProps;
/**
 * A nice animated Toggle rendered using only CSS
 */
export declare class Toggle extends React.PureComponent<Toggle.Props> {
    private checkbox;
    componentDidMount(): void;
    componentDidUpdate(): void;
    updateCheckbox: (props: ToggleDefaultedProps) => void;
    getHalfSize(size: string | number): string | number;
    onButtonClick: () => void;
    toggleOnSpace: (event: React.KeyboardEvent<HTMLElement>) => void;
    render(): JSX.Element;
}
export {};
