"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Toggle = void 0;
var React = __importStar(require("react"));
var classnames_1 = __importDefault(require("classnames"));
var log_1 = require("../utils/log");
/**
 * A nice animated Toggle rendered using only CSS
 */
var Toggle = /** @class */ (function (_super) {
    __extends(Toggle, _super);
    function Toggle() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.checkbox = null;
        _this.updateCheckbox = function (props) {
            if (_this.checkbox) {
                _this.checkbox.checked = props.value;
            }
        };
        _this.onButtonClick = function () {
            var _a = _this.props, value = _a.value, onChange = _a.onChange;
            onChange && onChange(!value);
        };
        _this.toggleOnSpace = function (event) {
            if (event.keyCode === 32) {
                _this.onButtonClick();
                event.stopPropagation();
                event.preventDefault();
            }
        };
        return _this;
    }
    Toggle.prototype.componentDidMount = function () {
        this.updateCheckbox(this.props);
    };
    Toggle.prototype.componentDidUpdate = function () {
        this.updateCheckbox(this.props);
    };
    Toggle.prototype.getHalfSize = function (size) {
        if (typeof size === 'string') {
            var unitMatch = /[a-z]+$/.exec(size); // only match characters at the end
            var number = parseFloat(size);
            var unit = unitMatch ? unitMatch[0] : '';
            if (isFinite(number)) {
                // we can still get NaN from parseFloat
                return "".concat(number / 2).concat(unit);
            }
            else {
                (0, log_1.warn)('Invalid size');
                return 0;
            }
        }
        else {
            return size / 2;
        }
    };
    Toggle.prototype.render = function () {
        var _this = this;
        var onButtonClick = this.onButtonClick;
        var _a = this
            .props, value = _a.value, _className = _a.className, size = _a.size, style = _a.style, disabled = _a.disabled;
        var buttonProps = {
            onClick: disabled ? undefined : onButtonClick,
            onMouseDown: function (e) { return e.preventDefault(); },
            onKeyDown: this.toggleOnSpace,
            style: size
                ? {
                    width: size,
                    height: this.getHalfSize(size),
                    borderRadius: this.getHalfSize(size)
                }
                : undefined
        };
        var className = (0, classnames_1.default)('toggle', { disabled: disabled }, _className);
        return (React.createElement("div", __assign({}, { className: className, style: style }),
            React.createElement("input", { className: "toggle-input", type: "checkbox", ref: function (c) {
                    _this.checkbox = c;
                }, value: value.toString(), readOnly: true }),
            React.createElement("label", __assign({ tabIndex: 0, className: "toggle-button" }, buttonProps))));
    };
    return Toggle;
}(React.PureComponent));
exports.Toggle = Toggle;
