import * as React from 'react';
import { ObjectOverwrite, Children } from '../utils';
import { Popover } from '../Popover/Popover';
export type TooltipRequiredProps = {
    /** the element over which the tooltip is shown */
    children: Children;
    /** popover props */
    popover: ObjectOverwrite<Popover.Props['popover'], {
        content: string;
        event?: undefined;
    }>;
    /** add class name */
    className?: string;
    /** add id */
    id?: string;
    /** add custom css style */
    style?: React.CSSProperties;
};
export type TooltipDefaultProps = {
    /** type - light | dark */
    type: Tooltip.Type;
    /** size - small | big */
    size: Tooltip.Size;
};
export declare namespace Tooltip {
    type Type = 'light' | 'dark';
    type Size = 'small' | 'big';
    type Props = TooltipRequiredProps & Partial<TooltipDefaultProps>;
}
export declare class Tooltip extends React.PureComponent<Tooltip.Props> {
    static defaultProps: TooltipDefaultProps;
    render(): JSX.Element;
}
