"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TooltipTouch = void 0;
var React = __importStar(require("react"));
var classnames_1 = __importDefault(require("classnames"));
var Tooltip_1 = require("./Tooltip");
var react_flexview_1 = __importDefault(require("react-flexview"));
var utils_1 = require("../utils");
var TooltipTouch = /** @class */ (function (_super) {
    __extends(TooltipTouch, _super);
    function TooltipTouch() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            tooltipLeft: 0,
            tooltipTop: 0,
            tooltipBottom: 0,
            tooltipRight: 0,
            isOpen: false
        };
        _this.onTouchStart = function () {
            var _a = _this.ref.getBoundingClientRect(), tooltipLeft = _a.left, tooltipTop = _a.top, tooltipBottom = _a.bottom, tooltipRight = _a.right;
            _this.timeout = window.setTimeout(function () {
                _this.setState({
                    tooltipLeft: tooltipLeft,
                    tooltipTop: tooltipTop,
                    tooltipBottom: tooltipBottom,
                    tooltipRight: tooltipRight,
                    isOpen: true
                });
            }, 200);
        };
        _this.onTouchMove = function (e) {
            var _a = _this.state, tooltipLeft = _a.tooltipLeft, tooltipTop = _a.tooltipTop, tooltipBottom = _a.tooltipBottom, tooltipRight = _a.tooltipRight, isOpen = _a.isOpen;
            if (isOpen) {
                var _b = e.touches[0], eventX = _b.pageX, eventY = _b.pageY;
                if (!(eventX <= tooltipRight &&
                    eventX >= tooltipLeft &&
                    eventY <= tooltipBottom &&
                    eventY >= tooltipTop)) {
                    _this.closeTooltip();
                }
            }
        };
        _this.onTouchEnd = function () { return _this.closeTooltip(); };
        _this.closeTooltip = function () {
            if (_this.timeout) {
                clearTimeout(_this.timeout);
            }
            _this.setState({
                tooltipLeft: 0,
                tooltipTop: 0,
                tooltipBottom: 0,
                tooltipRight: 0,
                isOpen: false
            });
        };
        return _this;
    }
    TooltipTouch.prototype.componentWillUnmount = function () {
        if (typeof this.timeout !== 'undefined') {
            clearTimeout(this.timeout);
        }
    };
    TooltipTouch.prototype.render = function () {
        var _this = this;
        var _a = this
            .props, popover = _a.popover, children = _a.children, className = _a.className, _tooltipProps = __rest(_a, ["popover", "children", "className"]);
        var isOpen = this.state.isOpen;
        var tooltipProps = __assign(__assign({}, _tooltipProps), { popover: __assign(__assign({}, popover), { isOpen: isOpen, className: (0, classnames_1.default)(popover.className, 'tooltip-touch') }), children: children });
        var spanStyle = isOpen
            ? {
                display: 'hidden',
                position: 'fixed',
                top: -1000
            }
            : undefined;
        return (React.createElement(react_flexview_1.default, { vAlignContent: "center", className: className, ref: function (r) {
                if (r) {
                    _this.ref = (0, utils_1.findDOMNode)(r);
                }
            }, onTouchStart: this.onTouchStart, onTouchEnd: this.onTouchEnd, onTouchMove: isOpen ? this.onTouchMove : undefined },
            React.createElement("span", { style: spanStyle }, children),
            isOpen && React.createElement(Tooltip_1.Tooltip, __assign({}, tooltipProps))));
    };
    TooltipTouch.defaultProps = {
        type: 'dark',
        size: 'small'
    };
    return TooltipTouch;
}(React.PureComponent));
exports.TooltipTouch = TooltipTouch;
