"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TransitionWrapper = void 0;
var React = __importStar(require("react"));
var classnames_1 = __importDefault(require("classnames"));
var omit = require("lodash/omit");
var Props = {
    children: true,
    component: true,
    transitionStyles: true,
    transitionEnterTimeout: true,
    transitionLeaveTimeout: true,
    onLeave: true,
    className: true,
    style: true
};
/**
 * To be used with `ReactTransitionGroup` to show transitions for a component
 */
var TransitionWrapper = /** @class */ (function (_super) {
    __extends(TransitionWrapper, _super);
    function TransitionWrapper() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this._replaceState = function (state) {
            _this.state = state;
            _this.forceUpdate();
        };
        _this.componentWillAppear = function (callback) { return _this.componentWillEnter(callback); };
        _this.componentDidAppear = function () { return _this.componentDidEnter(); };
        _this.componentWillEnter = function (callback) {
            return _this.startAnimation('enter', _this.props.transitionEnterTimeout, callback);
        };
        _this.componentDidEnter = function () {
            var transitionStyles = _this.props.transitionStyles;
            return _this._replaceState({ defaultStyle: transitionStyles.default });
        };
        _this.componentWillLeave = function (callback) {
            return _this.startAnimation('leave', _this.props.transitionLeaveTimeout, callback);
        };
        _this.componentDidLeave = function () {
            var onLeave = _this.props.onLeave;
            onLeave();
        };
        _this.getStyle = function () {
            var style = _this.props.style;
            var _a = _this.state, animationStart = _a.animationStart, animationEnd = _a.animationEnd, defaultStyle = _a.defaultStyle;
            var userTransform = (animationEnd || animationStart || defaultStyle || {}).transform;
            return __assign(__assign(__assign(__assign(__assign({}, style), defaultStyle), animationStart), animationEnd), { transform: (0, classnames_1.default)(userTransform, style.transform) });
        };
        return _this;
    }
    TransitionWrapper.prototype.startAnimation = function (anim, timeout, callback) {
        var _this = this;
        var transitionStyles = this.props.transitionStyles;
        var animationStart = transitionStyles[anim];
        var animationEnd = transitionStyles["".concat(anim, "Active")];
        var initState = { animationStart: animationStart, transitionClassName: anim };
        var activeState = {
            animationEnd: animationEnd,
            transitionClassName: (0, classnames_1.default)(anim, "".concat(anim, "-active"))
        };
        this._replaceState(initState);
        setTimeout(function () {
            _this.setState(activeState);
            setTimeout(callback, timeout);
        }, 30); // if the render is too fast the animation fails... 30ms is an empiric value.
    };
    TransitionWrapper.prototype.render = function () {
        if (!this.state) {
            return null;
        }
        var _a = this.props, children = _a.children, className = _a.className, component = _a.component;
        var transitionClassName = this.state.transitionClassName;
        var props = __assign({ className: (0, classnames_1.default)(className, transitionClassName), style: this.getStyle() }, omit(this.props, Object.keys(Props)));
        return React.createElement(component, props, children);
    };
    TransitionWrapper.defaultProps = {
        transitionStyles: {},
        style: {},
        component: 'div',
        onLeave: function () { }
    };
    return TransitionWrapper;
}(React.PureComponent));
exports.TransitionWrapper = TransitionWrapper;
